Package: comapr
Title: Crossover analysis and genetic map construction
Version: 1.16.0
Authors@R: 
    person(given = "Ruqian",
           family = "Lyu",
           role = c("aut", "cre"),
           email = "xiaoru.best@gmail.com",
           comment = c(ORCID = "0000-0002-7736-6612"))
Description: comapr detects crossover intervals for single gametes from their 
    haplotype states sequences and stores the crossovers in GRanges object.
    The genetic distances can then be calculated via the mapping functions 
    using estimated crossover rates for maker intervals. Visualisation functions 
    for plotting interval-based genetic map or cumulative genetic distances are 
    implemented, which help reveal the variation of crossovers landscapes across 
    the genome and across individuals. 
biocViews: Software, SingleCell, Visualization, Genetics
Depends: R (>= 4.1.0)
Imports: methods, ggplot2, reshape2, dplyr, gridExtra, plotly,
        circlize, rlang, GenomicRanges, IRanges, foreach, BiocParallel,
        GenomeInfoDb, scales, RColorBrewer, tidyr, S4Vectors, utils,
        Matrix, grid, stats, SummarizedExperiment, plyr, Gviz
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.2.3
VignetteBuilder: knitr
Suggests: BiocStyle, knitr, rmarkdown, testthat (>= 2.1.0), statmod
git_url: https://git.bioconductor.org/packages/comapr
git_branch: RELEASE_3_23
git_last_commit: 468442a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:22:13 UTC; biocbuild
Author: Ruqian Lyu [aut, cre] (ORCID: <https://orcid.org/0000-0002-7736-6612>)
Maintainer: Ruqian Lyu <xiaoru.best@gmail.com>

comapr
================

[![codecov](https://codecov.io/github/ruqianl/comapr/branch/master/graphs/badge.svg)](https://codecov.io/github/ruqianl/comapr/)
[![Build
Status](https://travis-ci.com/ruqianl/comapr.svg?branch=master)](https://travis-ci.com/ruqianl/comapr)

## Install

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("comapr")
```

## Introduction

<img src='Meta/hexComapr_crop.png' align="right" height="139" />

`comapr` is an R package for finding crossovers for SNP marker intervals
by detecting haplotype shifts across groups of samples.

## From marker genotyping results in data.frame

`comapr` can be applied for detecting crossovers from genotyping results
of makers across samples in a marker by sample data.frame.

``` r
library(comapr)
head(snp_geno)
#>   CHR      POS       rsID C57BL.6J FVB.NJ..i.  X92 X93 X94 X95 X96 X97  X98
#> 1   1  4526088 rs13475701       GG         CC   CC  CC  CC  CC  CC  CC   CG
#> 2   1  5595513 rs13475705       TT         CC   CC  CC  CC  CC  CC  CC   CT
#> 3   1  6057774  rs3710263       CC         TT   TT  TT  TT  TT  TT  TT   TC
#> 4   1  6655964 rs13475709       CC         GG   GG  GG  GG  GG  GG  GG   CG
#> 5   1 21638464  rs6253968       TT         CC Fail  CC  CC  CC  CC  CC Fail
#> 6   1 22665060  rs6361963       AA         GG   AG  GG  GG  GG  GG  GG   AG
#>    X99 X100 X101 X102 X103 X104 X105 X106 X107 X108 X109 X110 X111 X112 X113
#> 1   CG   CC   CG   CG   CC   CG   CG   CC   CC   CC   CC   CG   CC   CC   CC
#> 2   CT   CC   CT   CT   CC   CT   CT   CC   CC   CC   CC   CT   CC   CC   CC
#> 3   TC   TT   TC   TC   TT   TC   TC   TT   TT   TT   TT   TC   TT   TT   TT
#> 4   CG   GG   CG   CG   GG   CG   CG   GG   GG   GG   GG   CG   GG   GG   GG
#> 5 Fail   CC   TC   TC   CC   CC   CC   CC   CC   CC Fail   TC   CC   CC   CC
#> 6   AG   GG   AG   AG   GG   GG   GG   AG   GG   GG   GG   AG   GG   GG   GG
```

## From sgcocaller’s sparse matrices

`comapr` is also engineered to analyze the outputs from a single-sperm
crossover calling tool
[`sgcocaller`](https://gitlab.svi.edu.au/biocellgen-public/sgcocaller)

``` r
list.files("inst/extdata/")
#>  [1] "s1_barcodes.txt"        "s1_chr1_altCount.mtx"   "s1_chr1_snpAnnot.txt"  
#>  [4] "s1_chr1_totalCount.mtx" "s1_chr1_vi.mtx"         "s1_chr1_viSegInfo.txt" 
#>  [7] "s1_chr2_altCount.mtx"   "s1_chr2_snpAnnot.txt"   "s1_chr2_totalCount.mtx"
#> [10] "s1_chr2_vi.mtx"         "s1_chr2_viSegInfo.txt"  "s1_chr3_altCount.mtx"  
#> [13] "s1_chr3_snpAnnot.txt"   "s1_chr3_totalCount.mtx" "s1_chr3_vi.mtx"        
#> [16] "s1_chr3_viSegInfo.txt"  "s1_chr4_altCount.mtx"   "s1_chr4_snpAnnot.txt"  
#> [19] "s1_chr4_totalCount.mtx" "s1_chr4_vi.mtx"         "s1_chr4_viSegInfo.txt" 
#> [22] "s1_chr5_altCount.mtx"   "s1_chr5_snpAnnot.txt"   "s1_chr5_totalCount.mtx"
#> [25] "s1_chr5_vi.mtx"         "s1_chr5_viSegInfo.txt"  "s2_barcodes.txt"       
#> [28] "s2_chr1_snpAnnot.txt"   "s2_chr1_vi.mtx"         "s2_chr1_viSegInfo.txt" 
#> [31] "s2_chr2_snpAnnot.txt"   "s2_chr2_vi.mtx"         "s2_chr2_viSegInfo.txt" 
#> [34] "s2_chr3_snpAnnot.txt"   "s2_chr3_vi.mtx"         "s2_chr3_viSegInfo.txt" 
#> [37] "s2_chr4_snpAnnot.txt"   "s2_chr4_vi.mtx"         "s2_chr4_viSegInfo.txt" 
#> [40] "s2_chr5_snpAnnot.txt"   "s2_chr5_vi.mtx"         "s2_chr5_viSegInfo.txt"
```

## Visualizing feature of single sperms

![PerCellQC](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-6-1.png)

## Crossover positions

![Crossover
Positions](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-31-1.png)

![Crossover counts per
group](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-33-1.png)

## Cumumative Genetic distances across intervals

![Genetic Distances Per
Chromosome](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-41-1.png)
![Whole Genome Cumulative Genetic
Distances](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-42-1.png)

## Resampling methods for comparing groups

![Permutation](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-48-1.png)

![Bootstrapping](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/figure/Crossover-identification-with-sscocaller-and-comapr.Rmd/unnamed-chunk-45-1.png)

## Analysis workflow for demonstration of `comapr` on a single-sperm DNAseq dataset

We demonstrate the usage of `sgcocaller` and `comapr` for identifying
and visualising crossovers regions from single-sperm DNA sequencing
dataset
[here](https://biocellgen-public.svi.edu.au/hinch-single-sperm-DNA-seq-processing/Crossover-identification-with-sscocaller-and-comapr.html)

## Functions for formatting input genotype data.frame including `.label_gt`,
## `.correct_gt`, `.correct_ref` `.change_missing` and a simple imputation
## for missing value method `fill_failed`

#' @import methods
NULL

#' `label_gt` for changing genotypes in alleles format to labels
#'
#' It turns a vector of Genotypes to a vector of Labels consist of
#' `Homo_ref`, `Homo_alt`, and `Het` given the known genotypes for reference
#' and alternative strains.
#' @param s_gt
#' s_gt, a vector of genotypes for one sample across markers
#' @param ref
#' ref, a vector of genotypes for reference strain across markers
#' @param alt
#' alt, a vector of genotypes for alternative strain across markers
#' @param failed
#' what was used for encoding failed genotype calling such as "Fail" in example
#' @return
#' a vector of labels \code{Homo_ref, Homo_alt, Het} indicating the progeny's
#' genotypes across markers
#' @details
#' This function takes the a sample's genotype across each SNP marker in alleles
#' and compare with genotypes of in-bred reference and alternative strains to.
#' If the sample's genotype for a particular SNP marker is the same with the
#' reference strain, it is labelled as Homo_ref \code{homogeneous reference} for
#' a particular SNP marker; if the sample's genotype is the same with the
#' alternative strain it is labelled as Homo_alt \code{homogeneous alternative}
#' for a particular SNP marker; if the sample's genotype is heterozygous then it
#' is labeled as Het \code{heterozygous} for this particular genotypes. If it
#' does not fall in any of the three cases, it is labelled as the string
#' specified by the argument `missing`.
#'
#' Note that the wrong/failed genotype is labelled as the string in `missing`
#' after this function.
#' If there is a different label for failed genotype, provide the label using
#' the `missing` argument.
#'
#' @keywords internal
#' @author Ruqian Lyu

.label_gt <- function(s_gt,ref,alt,failed = "Fail"){
  stopifnot(length(s_gt) == length(ref))
  stopifnot(length(ref) == length(alt))

  ## initialise the vector of GT with `missing`
  tem <- rep(failed,length(s_gt))

  ## if the genotype is the same as reference:
  tem[s_gt == ref] <- "Homo_ref"
  ## if the genotype is the same as alternative:
  tem[s_gt == alt] <- "Homo_alt"
  ## het1 GC
  het1 <- paste0(strtrim(ref,1),strtrim(alt,1))
  ## het2 CG
  het2 <- paste0(strtrim(alt,1),strtrim(ref,1))

  ## if the genotype is the same as het1 or het2:
  tem[s_gt == het1 | s_gt == het2] <- "Het"

  ## the wrong GTs are GTs that can not be converted to Home_ref, Home_alt, Het
  ## or Fail
  ## the wrong GT will be converted to `Fail`

  return(tem)
}



#' change SNPs with genotype 'Fail' to \code{NA}
#'
#' @param s_gt, a column of labelled genotypes
#' @param missing, the string used for encoding missing values default to
#' \code{Fail}
#' @return
#' a vector of genotypes with Fail substituted by `NA`
#' @details

#' calculation.
#'
#' @keywords internal
#' @author  Ruqian Lyu

.change_missing <- function(s_gt, missing = "Fail"){

  if(! any(s_gt %in% missing)){
    return(s_gt)
  } else {

    missing_index  <-  which(s_gt %in% missing)

    s_gt[missing_index] <-  NA
  }
  return(s_gt)
}


#' Infer the genotype of failed SNPs

#' If we have a \code{Fail} in the genotype data and the \code{Fail} in a block
#' of either Home_alt, or Het, we fill in the \code{Fail}s using values of the
#' ones adjacent to it, otherwise they remain as "Fail" to indicate missing
#' values.
#'
#' @param s_gt, a column of labelled genotypes
#' @param fail, the string that is used for encoding failed genotype results,
#' default to \code{Fail}
#' @param chr, the factor vector indicating which chromosomes the markers are
#' on, default to \code{NULL} which means the input markers are all on the same
#' chromosome.
#'
#' @return
#' a vector of genotypes with Failed genotype imputed or changed to `NA` if not
#' imputable
#' @keywords internal
#' @author  Ruqian Lyu

fill_fail <- function(s_gt,fail = "Fail",chr = NULL){
  stopifnot(length(s_gt) >=3)

  if(! any(s_gt == fail)){
    return(s_gt)
  } else if(is.null(chr)) {
    fail_index  <-  grep(fail,s_gt)
    before_index <- fail_index -1
    after_index <- fail_index +1
    if(any(before_index <1)){
      lo_i <- fail_index[which(before_index<1)]
      fail_index <- fail_index[-which(before_index<1)]
      before_index <- fail_index -1
      after_index <- fail_index + 1
    }
    if(any(after_index >= length(s_gt))){
      lo_i <- fail_index[which(after_index > length(s_gt))]
      fail_index <- fail_index[-which(after_index > length(s_gt))]
      before_index <- fail_index -1
      after_index <- fail_index + 1
    }

    able_infer_index <- fail_index[which(s_gt[before_index] == s_gt[after_index]
                                         & s_gt[before_index] != fail)]
    s_gt[able_infer_index] <- s_gt[able_infer_index-1]

    return(s_gt)

  } else { # chr is not null, we should do this for each group of markers
    stopifnot(length(chr) == length(s_gt))
    chrs <- levels(chr)
    names(s_gt) <- paste0("m",seq_len(length(s_gt)))
    to_return <- lapply(chrs, function(s_gt_chr){
      fill_fail(s_gt[chr==s_gt_chr],chr =NULL)
    })
    to_return <- unlist(to_return)
    to_return <- to_return[ paste0("m",seq_len(length(s_gt)))]
    names(to_return) <- NULL
    return(to_return)
  }
}


#' correctGT
#'
#' function for formatting and correction genotypes of markers
#'
#' This function changes genotype in alleles to genotype labels, change Homo_ref
#' to Hets/Fail, infer Failed genotype, and change "Failed" to NA for
#' counting crossover later
#'
#'
#' @param gt_matrix
#' the input genotype matrix of markers by samples with rownames as marker IDs
#' and column names as sample IDs
#' @param ref
#'  a vector of genotypes of the inbred reference strain
#' @param alt
#'  a vector of genotypes of the inbred alternative strain
#' @param failed
#' what was used for encoding failed genotype calling such as "Fail" in example
#' data \code{snp_geno}
#' @param wrong_label
#' what would be considered a wrong genotype label for example Homo_ref which
#' should not be in the possible genotypes of BC1F1 samples
#'
#'
#' @details
#' This function changes genotype in alleles to labels by calling internal
#' functions \code{lable_gt}, and changes the wrong genotype Homo_ref to Fail by
#' calling \code{.change_missing}.
#'
#' @return
#' a genotype data.frame of sample genotypes with dimension as the input
#' `gt_matrix` with genotypes converted to labels and failed calls are changed
#' to NA.
#'
#' @examples
#' data(snp_geno_gr)
#' data(parents_geno)
#' snp_gt_crt <- correctGT(gt_matrix = GenomicRanges::mcols(snp_geno_gr),
#'                       ref = parents_geno$ref,
#'                       alt = parents_geno$alt,
#'                       fail = "Fail",
#'                       wrong_label = "Homo_ref")
#' @export
#'
#' @author Ruqian Lyu

correctGT <- function(gt_matrix, ref, alt,
                      failed = 'Fail', wrong_label = "Homo_ref")
{
  stopifnot(length(ref) == length(alt))
  stopifnot(length(ref) == dim(gt_matrix)[1])

  ### change  GT to labels, non matched GTs are changed to Fail
  row_names <- rownames(gt_matrix)

  gt_matrix <- apply(as.matrix(gt_matrix),2, .label_gt,
                     ref = ref,
                     alt = alt,
                     failed = failed)


  ## change SNPs with genotype `fail` to NA
  gt_matrix <- apply(as.matrix(gt_matrix),2, .change_missing,
                     missing = failed)
  ## Homo_ref calls are changed to Fail since it is not right
  gt_matrix <- apply(as.matrix(gt_matrix),2, .change_missing,
                     missing = wrong_label)
  rownames(gt_matrix) <- row_names

  gt_matrix

}

test_that("findDupSamples works", {
  data(snp_geno)
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[,1] <- or_geno[,5]
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  dups <- findDupSamples(cr_geno,)

  expect_equal(dups[,1], c("X92","X96"))


})

#
# test_that("findDupMarkers works", {
#   or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
#   rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
#   or_geno[,1] <- or_geno[,5]
#   cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
#                        alt = snp_geno$FVB.NJ..i.,
#                        chr = snp_geno$CHR)
#   dups <- findDupMarkers(cr_geno,plot = TRUE)
#   expect_true(length(dups)==2)
#
#
# })

test_that("Plot missing GT works", {
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[1,] <- rep("Fail",dim(or_geno)[2])
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                      alt = snp_geno$FVB.NJ..i.)
  p1 <- plotMissingGT(cr_geno)
  p2 <- plotMissingGT(cr_geno,plot_type = "bar")
  p3 <- plotMissingGT(cr_geno,plot_type = "bar", plot_wg = "TRUE")
  p4 <- plotMissingGT(cr_geno,plot_wg = "TRUE")

  expect_true('ggplot' %in% class(p1))
  expect_true('ggplot' %in% class(p2))
  expect_true('ggplot' %in% class(p3))
  expect_true('ggplot' %in% class(p4))


})

test_that("plotGTFreq works",{
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[1,] <- rep("Fail",dim(or_geno)[2])
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  ft_gt <- filterGT(cr_geno)
  p <- plotGTFreq(ft_gt)
  expect_true(class(p)[2]=="ggplot")
  
})

test_that("detectDisorted markers works", {
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[1,] <- rep("Fail",dim(or_geno)[2])
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  ft_gt <- filterGT(cr_geno)
  ft_gt[1,] <- "Het"
  disor_gt <- getDistortedMarkers(ft_gt)
  expect_true(disor_gt[1,2]==22)
})

test_that("label gt error", {
  data(snp_geno)
  expect_error(.label_gt(s_gt = snp_geno[,grep("X",colnames(snp_geno))],
                        ref = snp_geno$C57BL.6J,
                        alt = snp_geno$FVB.NJ..i.))
})

test_that("label gt successfully coverts Fail", {
  data(snp_geno)
  converted_gt <- .label_gt(s_gt = snp_geno[,"X98"],
                        ref = snp_geno$C57BL.6J,
                        alt = snp_geno$FVB.NJ..i.)
  expect_equal(converted_gt[5],"Fail")
})

test_that("label gt successfully coverts unknow GT to missinng", {
  data(snp_geno)
  s_gt <- snp_geno[,"X98"]
  s_gt[2] <- "KK"
  converted_gt <- .label_gt(s_gt = s_gt,
                           ref = snp_geno$C57BL.6J,
                           alt = snp_geno$FVB.NJ..i.,
                           failed = "Fail")

  expect_equal(converted_gt[2],"Fail")
})


test_that("label gt successfully coverts homo_ref", {
  data(snp_geno)
  s_gt <- snp_geno$C57BL.6J
  converted_gt <- .label_gt(s_gt = s_gt,
                           ref = snp_geno$C57BL.6J,
                           alt = snp_geno$FVB.NJ..i.)

  expect_equal(sum(converted_gt %in% "Homo_ref"),length(s_gt))
})


test_that("label gt successfully coverts homo_alt", {
  data(snp_geno)
  s_gt <- snp_geno$FVB.NJ..i.
  converted_gt <- .label_gt(s_gt = s_gt,
                           ref = snp_geno$C57BL.6J,
                           alt = snp_geno$FVB.NJ..i.)

  expect_equal(sum(converted_gt %in% "Homo_alt"),length(s_gt))
})



test_that("correct_ref successfully corrects Homo_ref to NA", {
  data(snp_geno)
  s_gt <- snp_geno[,5]
  s_gt[4] <- "Homo_ref"
  converted_gt <- correctGT(gt_matrix = s_gt,
                           ref = snp_geno$C57BL.6J,
                           alt = snp_geno$FVB.NJ..i.)


  expect_true(is.na(converted_gt[4]))
})

test_that("Plot counts by sample group with RSE", {

  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,
                               barcodeFile=NULL,
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)

  s1_counts <- countCOs(s1_rse_state)
  s1_counts$sampleGroup <- "s1"
  expect_s3_class(plotCount(s1_counts,group_by = 'sampleGroup',
                            plot_type ="hist"),
                  "ggplot")

  expect_s3_class(plotCount(s1_counts,group_by = 'sampleGroup'),
                  "ggplot")
})

test_that("Plot counts by chr and sample group with RSE", {

  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,
                               barcodeFile=NULL,
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)

  s1_counts <- countCOs(s1_rse_state)
  s1_counts$sampleGroup <- "s1"

  expect_s3_class(plotCount(s1_counts,
                            group_by = 'sampleGroup',
                            by_chr = TRUE,
                            plot_type = "error_bar"),
                  "ggplot")
  expect_s3_class(plotCount(s1_counts,
                            group_by = 'sampleGroup',
                            by_chr = TRUE),
                  "ggplot")

})


test_that("Plot counts by sample group with GRanges input", {

  data(snp_geno_gr)
  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  #  co_geno$interval_ID <- rownames(co_geno)
  # melt_geno <- melt(co_geno,id= 'interval_ID')
  # colnames(melt_geno) <- c("interval_ID","SampleID","Cross_over")
  marker_gr_cos <- countCOs(snp_geno_gr)

  expect_s3_class(plotCount(marker_gr_cos,group_by = 'sampleGroup'),"ggplot")
  expect_s3_class(plotCount(marker_gr_cos,group_by = 'sampleGroup',
                            plot_type = "hist"),"ggplot")

})



test_that("Plot counts by chr sample group with GRanges input", {

  data(snp_geno_gr)
  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  #  co_geno$interval_ID <- rownames(co_geno)
  # melt_geno <- melt(co_geno,id= 'interval_ID')
  # colnames(melt_geno) <- c("interval_ID","SampleID","Cross_over")
  marker_gr_cos <- countCOs(snp_geno_gr)

  expect_s3_class(plotCount(marker_gr_cos,
                            group_by = 'sampleGroup',
                            by_chr = TRUE),
                  "ggplot")

  expect_s3_class(plotCount(marker_gr_cos,
                            group_by = 'sampleGroup',
                            by_chr = TRUE,
                            plot_type = "hist"),
                  "ggplot")
})

test_that("countGT works", {
  data(snp_geno)
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[1,] <- rep("Fail",dim(or_geno)[2])
  cr_geno <- correctGT(or_geno,
                       ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  p1 <- countGT(cr_geno,plot = FALSE)
  p2 <- countGT(cr_geno,plot = TRUE, interactive = FALSE)
  p3 <- countGT(cr_geno,plot = TRUE, interactive = TRUE)
  p4 <- countGT(cr_geno)

  expect_true(class(p1) == 'list')
  expect_true(class(p2) == 'list')
  expect_true(class(p3$ply)[1] == 'plotly')
  expect_equal(p1,p4[c(2,3)])
})

BiocParallel::register(BPPARAM =BiocParallel::SerialParam())
data(snp_geno_gr)
data(parents_geno)

test_that("Calculate genetic distances", {

  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
#  co_geno$interval_ID <- rownames(co_geno)
  # melt_geno <- melt(co_geno,id= 'interval_ID')
  # colnames(melt_geno) <- c("interval_ID","SampleID","Cross_over")
  marker_gr_cos <- countCOs(snp_geno_gr)

  expect_equal(sum(marker_gr_cos[,"X92"]$X92),3)
  dist <- calGeneticDist(marker_gr_cos)
  expect_true(sum(dist$kosambi_cm)-169.53<0.01)
  #expect_true(abs(dist$kosambi_cm[1]-13.67603)<1e-3)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="1"]) - 47.71165 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="2"]) - 51.27605 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="4"]) - 42.82993 <0.001)


})

test_that("Calculate genetic distances for bined intervals", {
  data(snp_geno_gr)
  data(parents_geno)
  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  marker_gr_cos <- countCOs(snp_geno_gr)

  dist <- calGeneticDist(marker_gr_cos,bin_size = 1e7)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="1"]) - 47.71165 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="2"]) - 51.27605 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="4"]) - 42.82993 <0.001)

})



test_that("Calculate genetic distances for bined intervals,
          for RangedSummarizedExperiment", {
    demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
    s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                                 path=demo_path,
                                 barcodeFile=NULL,
                                 minSNP = 0,
                                 minlogllRatio = 50,
                                 bpDist = 100,
                                 maxRawCO=10,
                                 minCellSNP = 1)

    s1_counts <- countCOs(s1_rse_state)
    dist <- calGeneticDist(s1_counts,bin_size = 1e7)

    #expect_equivalent(colSums(as.matrix(assay(dist))),c( 1,1,0,0,0 ))
    expect_true(sum(dist$X)-41.84747 <0.001)
})

test_that("calGeneticDist works for RangedSummarizedExperiment ", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",
                               chroms=c("chr1"),
                               path=demo_path,
                               barcodeFile=NULL,
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)

  s1_counts <- countCOs(s1_rse_state)
  dist <- calGeneticDist(s1_counts)

  expect_equivalent(colSums(as.matrix(assay(dist))), c(1,1,0,0,0 ))
  expect_true(sum(rowRanges(dist)$kosambi)-41.84747 <0.001)

})

test_that("filterGT works", {
  data(snp_geno)
  or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  or_geno[1,] <- rep("Fail",dim(or_geno)[2])
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  ft_gt <- filterGT(cr_geno)
  expect_false("1_4526088" %in% rownames(ft_gt))
  ft_gt <- filterGT(cr_geno,min_samples = 0)
  expect_true("1_4526088" %in% rownames(ft_gt))
  ft_gt <- filterGT(cr_geno,min_markers = 31)
  expect_false( sum(c("X92","X99") %in% colnames(ft_gt))>0)

  })

test_that("correctGT works", {
  data(snp_geno)
  data("parents_geno")
  or_geno <-snp_geno[,grep("X",colnames(snp_geno))]
  rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
  cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                       alt = snp_geno$FVB.NJ..i.)
  expect_false(any(cr_geno=="Fail",na.rm = TRUE))
  expect_true(is.na(cr_geno["1_21638464","X92"]))
})

#' readColMM
#'
#' Modified the `Matrix::readMM` function for reading matrices stored in the
#' Harwell-Boeing or MatrixMarket formats but only reads selected column.
#'
#' See \code{\link[Matrix]{readMM}}
#'
#' @param file the name of the file to be read from as a character scalar. Those
#'  storing matrices in the MatrixMarket format usually end in ".mtx".
#' @param which.col An integer scalar, the column index
#' @param chunk, An integer scalar indicating the chunk size to use,
#' i.e., number of rows to read at any one time.
#' @author Ruqian Lyu
#' @export
#' @examples
#' demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' readColMM(file = paste0(demo_path,"s1_chr1_vi.mtx"), which.col=2,chunk=2)
#' @return
#' A sparse matrix object that inherits from the "Matrix" class which the original
#' dimensions.To get the vector of the specified column, one need to subset
#' the matrix to select the column with the same index.
#'
readColMM <- function(file,which.col,chunk=1000L)
{
  stopifnot(length(which.col)==1)
  if (is.character(file))
    file <- if(file == "") stdin() else file(file)
  if (!inherits(file, "connection"))
    stop("'file' must be a character string or connection")
  if (!isOpen(file)) {
    open(file)
    on.exit(close(file))
  }
  scan1 <- function(what, ...)
    scan(file, nmax = 1, what = what, quiet = TRUE, ...)

  if (scan1(character()) != "%%MatrixMarket")# hdr
    stop("file is not a MatrixMarket file")
  if (!(typ <- tolower(scan1(character()))) %in% "matrix")
    stop(gettextf("type '%s' not recognized", typ), domain = NA)
  if (!(repr <- tolower(scan1(character()))) %in% c("coordinate", "array"))
    stop(gettextf("representation '%s' not recognized", repr), domain = NA)
  elt <- tolower(scan1(character()))
  if (!elt %in% c("real", "complex", "integer", "pattern"))
    stop(gettextf("element type '%s' not recognized", elt), domain = NA)

  sym <- tolower(scan1(character()))
  if (!sym %in% c("general", "symmetric", "skew-symmetric", "hermitian"))
    stop(gettextf("symmetry form '%s' not recognized", sym), domain = NA)
  nr <- scan1(integer(), comment.char = "%")
  nc <- scan1(integer())
  nz <- scan1(integer())
  checkIJ <- function(els) {

    if(any(els$i < 1 | els$i > nr))
      stop("readMM(): row	 values 'i' are not in 1:nr", call.=FALSE)
    if(any(els$j < 1 | els$j > nc))
      stop("readMM(): column values 'j' are not in 1:nc", call.=FALSE)
  }
  if (repr == "coordinate") {
    switch(elt,
           "real" = ,
           "integer" = {
             ## TODO: the "integer" element type should be returned as
             ##       an object of an "iMatrix" subclass--once there are

             pointer.col <- 0
             while(pointer.col != which.col){
               els <- scan1(what = list(i = integer(),
                                        j = integer(),
                                        x = numeric()))
               pointer.col <- els$j
             }

             # Reading it in, chunk by chunk (see behavior of nmax= when what=
             # is a list).
             els <- list(i=els$i,j=els$j,x=els$x)

             repeat {
               current <- scan(file, what=list(i= integer(),
                                               j= integer(),
                                               x= numeric()),
                               nmax=chunk, quiet=TRUE)
               checkIJ(current)

               if ((current$j[length(current$j)] != which.col) |
                   (length(current$i) < chunk)){
                 els <- list(i = c(els$i,current$i[current$j==which.col]),
                             j = c(els$j,current$j[current$j==which.col]),
                             x = c(els$x,current$x[current$j==which.col]))
                 break

               } else {
                 els <- list(i = c(els$i,current$i),
                             j = c(els$j,current$j),
                             x = c(els$x,current$x))

               }

            }

             switch(sym,
                    "general" = {
                      new("dgTMatrix", Dim = c(nr, nc), i = els$i - 1L,
                          j = els$j - 1L, x = els$x)
                    },
                    "symmetric" = {
                      new("dsTMatrix", uplo = "L", Dim = c(nr, nc),
                          i = els$i - 1L, j = els$j - 1L, x = els$x)
                    },
                    "skew-symmetric" = {
                      stop("symmetry form 'skew-symmetric' not yet implemented
                           for reading")
                      ## FIXME: use dgT... but must expand the (i,j,x) slots!
                      new("dgTMatrix", uplo = "L", Dim = c(nr, nc),
                          i = els$i - 1L, j = els$j - 1L, x = els$x)

                    },
                    "hermitian" = {
                      stop("symmetry form 'hermitian' not yet implemented for
                           reading")
                    },
                    ## otherwise (not possible; just defensive programming):
                    stop(gettextf("symmetry form '%s' is not yet implemented",
                                  sym), domain = NA)
             )
           },
           "pattern" = {
             els <- scan(file, nmax = nz, quiet = TRUE,
                         what = list(i = integer(), j = integer()))
             checkIJ(els)
             switch(sym,
                    "general" = {
                      new("ngTMatrix", Dim = c(nr, nc),
                          i = els$i - 1L, j = els$j - 1L)
                    },
                    "symmetric" = {
                      new("nsTMatrix", uplo = "L", Dim = c(nr, nc),
                          i = els$i - 1L, j = els$j - 1L)
                    },
                    "skew-symmetric" = {
                      stop("symmetry form 'skew-symmetric' not yet implemented
                           for reading")
                      ## FIXME: use dgT... but must expand the (i,j,x) slots!
                      new("ngTMatrix", uplo = "L", Dim = c(nr, nc),
                          i = els$i - 1L, j = els$j - 1L)

                    },
                    "hermitian" = {
                      stop("symmetry form 'hermitian' not yet implemented for
                           reading")
                    },
                    ## otherwise (not possible; just defensive programming):
                    stop(gettextf("symmetry form '%s' is not yet implemented",
                                  sym), domain = NA)
             )
           },
           "complex" = {
             stop("element type 'complex' not yet implemented")
           },
           ## otherwise (not possible currently):
           stop(gettextf("'%s()' is not yet implemented for element type '%s'",
                         "readMM", elt), domain = NA))
  }
  else
    stop(gettextf("'%s()' is not yet implemented for  representation '%s'",
                  "readMM", repr), domain = NA)
}

test_that("Read col MM works  for column 2 ", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_vi <-   readColMM(file = paste0(demo_path,"s1_chr1_vi.mtx"), which.col=2,
                       chunk=2)
  expect_true(Matrix::colSums(s1_vi)[1]==0)
  expect_true(Matrix::colSums(s1_vi)[3]==0)
  expect_true(Matrix::colSums(s1_vi)[4]==0)
  expect_true(Matrix::colSums(s1_vi)[5]==0)
})


test_that("Read col MM works for column 3 ", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_vi <-   readColMM(file = paste0(demo_path,"s1_chr1_vi.mtx"), which.col=3,
                       chunk=2)
  expect_true(Matrix::colSums(s1_vi)[1]==0 & Matrix::colSums(s1_vi)[2]==0 )
  expect_true(Matrix::colSums(s1_vi)[4]==0)
  expect_true(Matrix::colSums(s1_vi)[5]==0)
})


test_that("Read col MM works for larger chunks 10 ", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_vi <-   readColMM(file = paste0(demo_path,"s1_chr1_vi.mtx"), which.col=3,
                       chunk=10)
  expect_true(Matrix::colSums(s1_vi)[1]==0 & Matrix::colSums(s1_vi)[2]==0 )
  expect_true(Matrix::colSums(s1_vi)[4]==0)
  expect_true(Matrix::colSums(s1_vi)[5]==0)
})

#' plotGeneticDist
#'
#' Plotting the calculated genetic distanced for each bin or marker interval
#' supplied by the GRanges object
#'
#' @importFrom dplyr filter left_join
#' @importFrom dplyr %>%
#' @importFrom dplyr mutate
#' @importFrom scales unit_format
#' @importFrom tidyr pivot_longer
#' @importFrom rlang .data
#' @importFrom GenomeInfoDb genome seqinfo
#' @importFrom GenomicRanges GRanges mcolAsRleList sort width
#' @importFrom GenomicRanges tileGenome binnedAverage mcols
#' @importFrom GenomeInfoDb sortSeqlevels seqlevels
#' @importFrom S4Vectors Rle
#' @import ggplot2
#' @importFrom RColorBrewer brewer.pal
#' @export
#' @param gr GRanges object with genetic distances calculated for marker
#' intervals
#' @param bin TRUE or FALSE, indicating whether the supplied GRange objecct
#' is for binned interval
#' @param chr the specific chrs selected to plot
#' @param cumulative TRUE or FALSE, indicating whether it plots the bin-wise
#' genetic distances or the cumulative distances

#' @return
#' ggplot2 plot
#' @author Ruqian Lyu
#'
#' @examples
#' data(coCount)
#' dist_se <- calGeneticDist(coCount)
#' plotGeneticDist(SummarizedExperiment::rowRanges(dist_se))

plotGeneticDist <- function(gr,bin=TRUE,chr=NULL,cumulative=FALSE){
  col_to_plot <- colnames(mcols(gr))
  sample_group_colors <- brewer.pal(ifelse(length(col_to_plot)>2,
                                                         length(col_to_plot),3),
                                                  name="Set1")
  names(sample_group_colors)[seq_along(col_to_plot)] <- col_to_plot

  sample_group_colors <- sample_group_colors[col_to_plot]

  if(cumulative){
    mcols(gr) <- apply(mcols(gr),2 ,
                       function(x,
                                seq = as.character(seqnames(gr))){
      temp_df <- data.frame(x=x,seq=seq) %>% group_by(seq) %>%
        mutate(cum = cumsum(x))
      temp_df$cum
      })
  }
  plot_df <- data.frame(gr)
  ## in case colnames for groups (| -> .) was escaped
  rename_cols <- (ncol(plot_df)-length(col_to_plot)+1):ncol(plot_df)
  colnames(plot_df)[rename_cols] <- col_to_plot

  plot_df <- plot_df %>% mutate(x_tick = 0.5*(.data$start + .data$end))

  plot_df <- plot_df %>% pivot_longer(cols=col_to_plot,
                                             names_to = "SampleGroup",
                                             values_to = "bin_dist")
  x_tick <- bin_dist <- end <- SampleGroup <- NULL
    if(is.null(chr)){
      p <-  plot_df %>%
        ggplot()+
        geom_step(mapping = aes(x = x_tick ,y = bin_dist,
                              color=SampleGroup),size =1)
  } else {
      p <- plot_df %>% filter(seqnames %in% chr) %>%
        ggplot()+
        geom_step(mapping = aes(x = end,y=bin_dist,
                                color=SampleGroup),size =1)
  }

    p <- p + scale_x_continuous(labels = unit_format(unit = "M",
                                                        scale = 1e-6))+
      facet_wrap(.~seqnames,ncol=1,scales = "free")+
      theme_classic(base_size=18)+
      xlab("Chromosome positions")+
      scale_color_manual(values = sample_group_colors)

    if(cumulative){
      p + ylab("cumulative centiMorgans")
    } else {
      p + ylab("centiMorgans")
    }
}

#' Plot cumulative genetic distances across the genome
#'
#' This function takes the calculated genetic distances for all
#' marker intervals across all chromosomes provided and plot the
#' cumulative genetic distances
#' @importFrom GenomicRanges mcols
#' @importFrom dplyr select mutate
#' @export
#' @param  gr, GRanges object with genetic distances calculated for marker
#' intervals
#' @return A ggplot object
#' @examples
#' data(coCount)
#' dist_se <- calGeneticDist(coCount)
#' plotWholeGenome(SummarizedExperiment::rowRanges(dist_se))
plotWholeGenome <- function(gr){

  end <- chr_len <- tot <- all_of <- x_tick <- bin_dist <- SampleGroup <- NULL
  BPcum <- NULL

  mcols(gr) <- apply(mcols(gr), 2, function(x) {
    temp_df <- data.frame(x = x) %>%
      mutate(cum = cumsum(x))
    temp_df$cum
  })

  gr_df <- data.frame(gr,check.names = FALSE)
  col_to_plot <- gsub("\\|",".", colnames(mcols(gr)))
  don <- gr_df %>%

    # Compute chromosome size
    group_by(seqnames) %>%
    summarise(chr_len=max(end)) %>%

    # Calculate cumulative position of each chromosome
    mutate(tot=cumsum(as.numeric(chr_len))-chr_len) %>%
    select(-chr_len) %>%

    # Add this info to the initial dataset
    left_join(gr_df, ., by=c("seqnames"="seqnames")) %>%

    # Add a cumulative position of each SNP
    mutate( BPcum=end+tot,
                   x_tick = (0.5 * (start + end) + tot))

    plot_df <- don %>% pivot_longer(cols = all_of(col_to_plot),
                                         names_to = "SampleGroup",
                                         values_to = "bin_dist")
    p <- plot_df %>% ggplot() + geom_step(mapping = aes(x = x_tick,
                                                        y = bin_dist,
                                                        color = SampleGroup),
                                          size = 1)+

      theme_classic(base_size = 18) +
      xlab("Chromosome positions \n cumulative whole genome") +
      ylab("cumulative centiMorgans")

    axisdf <-  don %>% group_by(seqnames) %>%
      summarise(center=( max(BPcum) + min(BPcum) ) / 2 )

    p <- p+scale_x_continuous(labels = axisdf$seqnames, breaks= axisdf$center)+
      theme_classic(base_size = 15) +
      xlab("Chromosome positions \n cumulative whole genome") +
      ylab("cumulative centiMorgans")
    p
}

BiocParallel::register(BPPARAM =BiocParallel::SerialParam())

test_that("plotGeneticDist works", {

 # data(snp_geno_gr)
  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)

  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  marker_gr_cos <- countCOs(snp_geno_gr)

  expect_equal(sum(marker_gr_cos[,"X92"]$X92),3)

  dist <- calGeneticDist(marker_gr_cos)
  expect_true(sum(dist$kosambi_cm)-169.53<0.01)
  #expect_true(abs(dist$kosambi_cm[1]-13.67603)<1e-3)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="1"]) - 47.71165 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="2"]) - 51.27605 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="4"]) - 42.82993 <0.001)
  error_plot <- plotGeneticDist(dist,bin = FALSE,chr ="chr1")
  expect_error(plot(error_plot))

  good_plot <- plotGeneticDist(dist,bin = FALSE,chr ="1")
  expect_s3_class(plot(good_plot),"ggplot")

  })

test_that("plotting genetic distances for bined intervals", {
  data(snp_geno_gr)
  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  marker_gr_cos <- countCOs(snp_geno_gr)

  dist <- calGeneticDist(marker_gr_cos,bin_size = 1e7)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="1"]) - 47.71165 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="2"]) - 51.27605 <0.001)
  expect_true(sum(dist$kosambi_cm[as.character(seqnames(dist))=="4"]) - 42.82993 <0.001)

  good_plot <- plotGeneticDist(dist,bin = FALSE,chr ="1")
  expect_s3_class(plot(good_plot),"ggplot")
})



test_that("plot whole genome genetic distances for RangedSummarizedExperiment", {
            demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
            s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                                         path=demo_path,
                                         barcodeFile=NULL,
                                         minSNP = 0,
                                         minlogllRatio = 50,
                                         bpDist = 100,
                                         maxRawCO=10,
                                         minCellSNP = 1)

            s1_counts <- countCOs(s1_rse_state)
            dist <- calGeneticDist(s1_counts,bin_size = 1e7)

            expect_true(sum(dist$X)-41.84747 <0.001)
            expect_s3_class(plotWholeGenome(dist),"ggplot")
    })

test_that("plot genetic distances works for RangedSummarizedExperiment ", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",
                               chroms=c("chr1"),
                               path=demo_path,
                               barcodeFile=NULL,
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)

  s1_counts <- countCOs(s1_rse_state)
  dist <- calGeneticDist(s1_counts)

  expect_equivalent(colSums(as.matrix(assay(dist))), c(1,1,0,0,0 ))
  expect_true(sum(rowRanges(dist)$kosambi)-41.84747 <0.001)
  expect_s3_class(plotWholeGenome(rowRanges(dist)),"ggplot")

})

#' getSNPDensityTrack
#'
#' Generate the SNP density DataTrack (from `Gviz`) for selected chromosome
#' @inheritParams getCellAFTrack
#' @param log, whether the histogram of SNP density should be plotted on log
#' scale (log10)
#' @param plot_type, the DataTrack plot type, default to be `hist`
#'
#' @author Ruqian Lyu
#' @export
#' @return DataTrack object plotting the SNP density histogram
#'
#' @examples
#' demo_path <- system.file("extdata",package = "comapr")
#' snp_track <- getSNPDensityTrack(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1")
getSNPDensityTrack <- function(chrom = "chr1",
                               sampleName = "s1",
                               path_loc = ".",
                               nwindow = 80,
                               plot_type = "hist",
                               log = TRUE){

  snp_anno <- read.table(file=file.path(path_loc, paste0(sampleName,"_",chrom,
                                     "_snpAnnot.txt")),
                         header=TRUE)
  snp_track <- DataTrack( GRanges(seqnames = chrom,
                                  IRanges(start=snp_anno$POS,
                                          width = 1,
                                          genome = "mm10")),
                          name = "SNPs denstiy",
                          data = rep(1,nrow(snp_anno)),
                          window = nwindow,
                          aggregation  = .aggregation_fun_log(log,"sum"),
                          type=plot_type)

  snp_track
}

#' findDupSamples
#'
#' Find the duplicated samples by look at the number of matching genotypes
#' in all pair-wise samples
#'
#' @inherit countGT
#' @importFrom grid grid.text grid.rect gpar grid.circle
#' @importFrom circlize colorRamp2
#' @param threshold the frequency cut-off of number of matching genotypes out of
#' all geneotypes for determining whether the pair of samples
#' are duplicated, defaults to \code{0.99}. NAs are regarded as same genotypes for
#' two samples if they both have NA for a marker.

#' @param in_text whether text of frequencies should be displayed in the
#' heatmap cells
#' @export
#' @author Ruqian Lyu
#' @return
#' The paris of duplicated samples.
#'
#' @examples
#' data(snp_geno)
#' or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
#' rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
#' or_geno[,1] <- or_geno[,5]
#' cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
#'                     alt = snp_geno$FVB.NJ..i.)
#' dups <- findDupSamples(cr_geno)
findDupSamples <- function(geno, threshold = 0.99,
                           in_text = FALSE){


  geno <- as.matrix(geno)
  n <- seq_len( ncol(geno) )

  #  Make combinations
  id <- expand.grid( n , n )

  #  Get result
  out <- matrix( colSums( (is.na(geno[ , id[,1] ]) & is.na(geno[ , id[,2] ])) |
                            (geno[ , id[,1] ] == geno[ , id[,2] ]),
                          na.rm =TRUE) , ncol = length(n) )
  dimnames(out)[1] <- dimnames(geno)[2]
  dimnames(out)[2] <- dimnames(geno)[2]

  out_freq <- out / dim(geno)[1]
  l_out_freq <- out_freq
  l_out_freq[lower.tri(out_freq,diag=TRUE)] <- 0


  dups_index <- which(l_out_freq > threshold, arr.ind = TRUE)
  dups <- apply(dups_index,1,function(x)rownames(l_out_freq)[x])
  return(dups)
}

#' perCellChrQC
#'
#' A function that parses output ('_viSegInfo.txt' )from `sgcocaller`
#' \url{https://gitlab.svi.edu.au/biocellgen-public/sgcocaller} and
#' generate cell cell (per chr) summary statistics
#' @param path, the path to the files, with name patterns *{chrom}_vi.mtx,
#' *{chrom}_viSegInfo.txt, end with slash
#' @param barcodeFile, defaults to NULL, it is assumed to be in the same d
#' irectory as the other files and with name sampleName_barcodes.txt
#' @param chroms, the character vectors of chromosomes to parse. Multiple
#' chromosomes' results will be concated together.
#' @param sampleName, the name of the sample to parse which is used as prefix
#' for finding relevant files for the underlying sample
#' @param doPlot, whether a plot should returned, default to TRUE
#' @importFrom dplyr group_by summarise mutate filter select n if_else
#'
#' @return a list object that contains the data.frame with summarised statistics
#' per chr per cell and a plot (if doPlot)
#'
#'
#' @examples
#' demo_path <-system.file("extdata",package = "comapr")
#' pcQC <- perCellChrQC(sampleName="s1",chroms=c("chr1"),
#' path=demo_path,
#' barcodeFile=NULL)
#' @export
#' @author Ruqian Lyu
perCellChrQC <- function(sampleName,chroms = c("chr1","chr7","chr15"),
                         path,barcodeFile = NULL, doPlot = TRUE){

  barcodes <- .get_barcodes(barcodeFile = barcodeFile, sampleName = sampleName,
                            path = path)
  segInfo_chrs <- .get_segInfo_chrs(chroms = chroms, path = path,
                                    sampleName = sampleName)
  
  if(grepl("chr",segInfo_chrs$Chrom[1])){
    chr_levels <- paste0("chr",seq_len(23))
  } else {
    chr_levels <- unique(segInfo_chrs$Chrom)
  }

  plt_df <- segInfo_chrs %>% group_by(.data$ithSperm,.data$Chrom) %>%
    summarise(totalSNP = sum(.data$nSNP),
                     nCORaw = length(.data$nSNP)-1) %>%
    mutate(Chrom = factor(.data$Chrom,levels =  chr_levels))
  plt_df$barcode <- barcodes$barcodes[as.numeric(gsub("ithSperm",
                                                      "",plt_df$ithSperm))+1]
  plt_df$ithSperm <- NULL
  if(doPlot){
    plt <-
      ggplot(plt_df)+geom_point(mapping = aes(x = .data$nCORaw,
                                              y = .data$totalSNP))+
      scale_y_log10()+scale_x_log10()+facet_wrap(.~Chrom,ncol=5)+theme_classic()
    list(cellQC = plt_df,
         plot = plt)
  } else {
    plt_df
  }
}

#' countBinState
#'
#' Bins the chromosome into supplied number of bins and find the state of
#' the chromosome bins across all gamete cells
#'
#' This function is used for checking whether chromosome segregation pattern
#' obeys the expected ratio.
#'
#' @param chr, character, the chromosome to check
#' @param snpAnno, data.frame, the SNP annotation for the supplied chromosome
#' @param viState, dgTMatrix/Matrix, the viterbi state matrix, output from
#' `sgcocaller`
#' @param genomeRange, GRanges object with seqlengths information for the genome
#' @param ntile, integer, how many tiles the chromosome is binned into
#' @importFrom GenomicRanges tileGenome GRanges
#' @importFrom GenomeInfoDb seqlengths
#' @importFrom IRanges IRanges
#' @importFrom S4Vectors from to
#' @return a data.frame that contains chromosome bin segregation ratio
#'
#'
#' @examples
#'
#' chrom_info <- GenomeInfoDb::getChromInfoFromUCSC("mm10")
#' seq_length <- chrom_info$size
#' names(seq_length) <- chrom_info$chrom
#'
#' dna_mm10_gr <- GenomicRanges::GRanges(
#'   seqnames = Rle(names(seq_length)),
#'   ranges = IRanges(1, end = seq_length, names = names(seq_length)),
#'   seqlengths = seq_length)
#'
#' GenomeInfoDb::genome(dna_mm10_gr) <- "mm10"
#' demo_path <- system.file("extdata",package = "comapr")
#' sampleName <- "s1"
#' chr <- "chr1"
#' vi_mtx <- Matrix::readMM(file = paste0(demo_path,"/", sampleName, "_",
#'                                        chr, "_vi.mtx"))
#'
#' snpAnno <- read.table(file = paste0(demo_path,"/", sampleName,
#'                                     "_", chr, "_snpAnnot.txt"),
#'                                     stringsAsFactors = FALSE,
#'                       header = TRUE)
#'
#' countBinState(chr = "chr1",snpAnno = snpAnno,
#' viState = vi_mtx,genomeRange = dna_mm10_gr, ntile = 1)
#'
#' @author Ruqian Lyu
#' @export
countBinState <- function(chr,
                          snpAnno,
                          viState,
                          genomeRange,
                          ntile = 5){
  tiles <- tileGenome(seqlengths(genomeRange)[chr],
                                     ntile = ntile)
  binned_dna_mm10_gr <- unlist(tiles)

  vi_gr <- GRanges(seqnames = chr,
                                  ranges = IRanges(start = snpAnno$POS,
                                                            width = 1))
  hits <- findOverlaps(vi_gr,binned_dna_mm10_gr)


  vi_bins <- suppressMessages(do.call(rbind,(apply(viState,2, function(x){
    data.frame(state = x, bins = to(hits)) %>% group_by(.data$bins) %>%
      summarise(nstate2 = sum(.data$state ==2),
                       nstate1 = sum(.data$state ==1))
  }))))
  vi_bins %>% mutate(binState =
                              if_else(.data$nstate2>.data$nstate1,
                                             "state2",
                                             "state1")) %>%
    group_by(.data$bins) %>%
    summarise(binSegRatio = sum(.data$binState=="state2")/n(),
                     nstate2 =sum(.data$binState=="state2"),
                     nstate1 = sum(.data$binState=="state1")) %>%
    mutate(Chrom = chr)
}

#' perSegChrQC
#'
#' Plots the summary statistics of segments that are generated by `sgcocaller`
#' \url{https://gitlab.svi.edu.au/biocellgen-public/sgcocaller}
#' which have been detected by finding consequtive viter states along the list
#' of SNP markers.
#'
#' It provides guidance in filtering out close double crossovers that are not
#' likely biological but due to technical reasons as well as crossovers that are
#' supported by fewer number of SNPs at the ends of the chromosomes.
#'
#' @param sampleName, the name of the sample to parse which is used as prefix
#' for finding relevant files for the underlying sample
#' @param chroms, the vector of chromosomes
#' @param path, the path to the files, with name patterns *{chrom}_vi.mtx,
#' *{chrom}_viSegInfo.txt, end with slash
#' @param barcodeFile, defaults to NULL, it is assumed to be in the same
#' directory as the other files and with name sampleName_barcodes.txt
#' @param maxRawCO, if a cell has more than `maxRawCO` number of raw crossovers
#' called across a chromosome, the cell is filtered out#'
#' @author Ruqian Lyu
#' @return Histogram plots for statistics summarized across all Viterbi state
#' segments
#' @examples
#' demo_path <- system.file("extdata",package = "comapr")
#' s1_rse_qc <- perSegChrQC(sampleName="s1",
#'                             chroms=c("chr1"),
#'                             path=demo_path, maxRawCO=10)
#'
#' @export
#'
perSegChrQC <- function(sampleName,chroms = c("chr1","chr7","chr15"),
                        path,barcodeFile = NULL,maxRawCO=10){
  logllRatio <- nSNP <- bpDist <- NULL
  
  barcodes <- .get_barcodes(barcodeFile = barcodeFile, sampleName = sampleName,
                            path = path)
  segInfo_chrs <- .get_segInfo_chrs(chroms = chroms, path = path,
                                    sampleName = sampleName)

  rmCells <-
    segInfo_chrs %>% group_by(.data$ithSperm,.data$Chrom) %>%
    summarise(nCORaw = length(.data$nSNP)-1) %>%
    filter(.data$nCORaw >= maxRawCO) %>%
    select(.data$ithSperm)
  rmCells <- unique(rmCells$ithSperm)

  p <- segInfo_chrs %>% filter(!.data$ithSperm %in% rmCells)%>%
    mutate(bpDist = (.data$Seg_end -.data$Seg_start)) %>%
    ggplot()+geom_point(mapping = aes(x =nSNP,y = bpDist,
                                      color = log10(logllRatio)))+
    scale_x_log10()+scale_y_log10()+scale_color_viridis_c()
 p
}

#' Read sample barcodes from barcodeFile and returne data.frame  
#' @noRd
#' @keywords internal

.get_barcodes <- function(barcodeFile, sampleName, path){
  
  if (is.null(barcodeFile)) {
    barcodeFile <- file.path(path,paste0(sampleName, "_barcodes.txt"))
  }
  stopifnot(file.exists(barcodeFile))
  
  barcodes <- read.table(file = barcodeFile,
                         stringsAsFactors = FALSE,
                         col.names = "barcodes")
  barcodes
}

#' Read segment info from each chrom and bind into one data.frame
#' @noRd
#' @keywords internal
.get_segInfo_chrs <- function(chroms, path, sampleName){
  
  result_fun <- function(){
    bpl_fun <- function(chr){
     segInfo <- read.table(file =
                             file.path(path,paste0(sampleName,
                                                   "_", chr, "_viSegInfo.txt")),
                            stringsAsFactors = FALSE,
                            col.names = c("ithSperm", "Seg_start", "Seg_end",
                                          "logllRatio", "nSNP", "State"))
      segInfo$Chrom <- chr
      segInfo
    } 
     bplapply(chroms, function(chr) bpl_fun(chr))
  }
 
  segInfo_chrs <- do.call(rbind,result_fun())
  segInfo_chrs
}

test_that("diagnostic function for per cell chr works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  sampleName <- "s1"
  pcqc <- perCellChrQC(sampleName,
                               chroms=c("chr1"),
                               path=demo_path)
  expect_true(is.list(pcqc))
  expect_true(length(pcqc)==2)
  expect_s3_class(pcqc$plot,"ggplot")

})

test_that("diagnostic per seg works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  sampleName <- "s1"
  suppressWarnings(psqc <- perSegChrQC(sampleName,
                                       chroms=c("chr1"),
                                       path=demo_path))

  expect_s3_class(psqc,"ggplot")

})

#' getCellCORange
#'
#' It finds the crossover intervals for a selected cell
#'
#' @param co_count, `GRanges` or `RangedSummarizedExperiment` object,
#' @param cellBarcode, the selected cell's barcode
#'
#' @return GRange object containing the crossover intervals for the selected
#' cell
#' @importFrom SummarizedExperiment assay assay<- rowRanges
#' @importFrom GenomicRanges mcols mcols<- reduce
#' @author Ruqian Lyu
#' @export
#' @examples
#'   demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_counts <- countCOs(s1_rse_state)
#'
#' co_ranges <- getCellCORange(cellBarcode = "BC1",
#'                             co_count = s1_counts)
getCellCORange <- function(co_count, cellBarcode){
  stopifnot(inherits(co_count, c("GRanges","RangedSummarizedExperiment")))
  if(is(co_count,"GRanges")){
    cell1_co <- mcols(co_count)[,cellBarcode]
    cell1_coRange <- granges(co_count)[cell1_co!=0]
    cell1_co <- cell1_co[cell1_co!=0]
  } else {
    cell1_co <- assay(co_count)[,cellBarcode]
    cell1_coRange <- rowRanges(co_count)[cell1_co!=0]
    cell1_co <- cell1_co[cell1_co!=0]

    mcols(cell1_coRange) <- cell1_co

  }

  co_range_cell1 <- reduce(cell1_coRange,min.gapwidth=2)
  co_range_cell1
}

#' getCellAFTrack
#' Generates the DataTracks for plotting AF and crossover regions
#'
#' It plots the raw alternative allele frequencies and highlight the crossover
#' regions for the selected cell.
#' @param chrom, the chromosome
#' @param path_loc, the path prefix to the output files from sscocaller including
#' "*_totalCount.mtx" and "_altCount.mtx"
#' @param sampleName, the sample name, which is the prefix of sscocaller's output
#' files
#'
#' @param nwindow, the number of windows for binning the chromosome
#' @param barcodeFile, the barcode file containing the list of cell barcodes used
#' as the input file for sscocaller
#' @param cellBarcode, the selected cell barcode
#' @param snp_track, the SNP position track which is used for obtaining the SNP
#' chromosome locations. It could be omitted and the SNP positions will be acquired
#' from the "*_snpAnnot.txt" file.
#' @param co_count, `GRange` or `RangedSummarizedExperiment` object,
#' returned by \code{countCO} that contains the crossover intervals and the number
#' of crossovers in each cell.
#' @param chunk, An integer scalar indicating the chunk size to use,
#' i.e., number of rows to read at any one time.
#'
#' @return The DataTrack object defined in \code{\link[Gviz]{DataTrack}}
#' @importFrom  Gviz DataTrack
#' @author Ruqian Lyu
#' @export
#' @examples
#' demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_counts <- countCOs(s1_rse_state)
#' af_co_tracks <- getCellAFTrack(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1",
#'                                barcodeFile = paste0(demo_path,
#'                                                     "s1_barcodes.txt"),
#'                                cellBarcode = "BC1",
#'                                co_count = s1_counts)
#'
getCellAFTrack <-  function(chrom = "chr1",
                            path_loc = "./output/firstBatch/WC_522/",
                            sampleName = "WC_522",
                            nwindow = 80,
                            barcodeFile,
                            cellBarcode,
                            co_count,
                            snp_track = NULL,
                            chunk = 1000L){
  stopifnot(length(cellBarcode)==1)
  initial_barcodes <- read.table(file = barcodeFile)
  whichCell <- match(cellBarcode, initial_barcodes$V1)

  dpMM <- readColMM(file = paste0(path_loc, sampleName,"_",
                                  chrom,"_totalCount.mtx"),
                    which.col = whichCell,
                    chunk = chunk)

  dpMM <- dpMM[,whichCell]

  altMM <- readColMM(file = paste0(path_loc, sampleName,"_",
                                   chrom, "_altCount.mtx"),
                     which.col = whichCell,
                     chunk = chunk)


  altMM <- altMM[,whichCell]
  af_data <- altMM/dpMM
  keep_snp <- !is.na(af_data)

  snp_pos <- .get_snp_pos(snp_track = snp_track, path_loc = path_loc,
                          sampleName = sampleName, chrom = chrom)

  af_track <- DataTrack(GRanges(seqnames = chrom,
                                IRanges(start=snp_pos[keep_snp],
                                        width = 1,
                                        genome = "mm10")),
                       name = paste0(cellBarcode, " AF"),
                       data = af_data[keep_snp],
                       window = nwindow,
                       na.rm=TRUE,
                       aggregation = "mean",
                       type="p",
                       ylim=0:1)
  co_range_cell1 <- getCellCORange(co_count, cellBarcode = cellBarcode)
  co_range_cell1[seqnames(co_range_cell1)==chrom,]

 list(af_track=af_track, co_range =co_range_cell1)
}

test_that("get Cell AF datatracks works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,barcodeFile=NULL,minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,maxRawCO=10,
                               minCellSNP = 0)
  s1_counts <- countCOs(s1_rse_state)

  af_co_tracks <- getCellAFTrack(chrom ="chr1",
                                 path_loc = demo_path,
                                 sampleName = "s1",
                                 barcodeFile = paste0(demo_path,
                                                      "s1_barcodes.txt"),
                 cellBarcode = "BC1",
                 co_count = s1_counts)
  expect_true(length(af_co_tracks) == 2)
  expect_true(GenomicRanges::start(af_co_tracks$co_range)==3201)
  expect_true(GenomicRanges::end(af_co_tracks$co_range)==5499)

  })


test_that("get cell CO range works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,barcodeFile=NULL,minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,maxRawCO=10,
                               minCellSNP = 0)
  s1_counts <- countCOs(s1_rse_state)

  co_ranges <- getCellCORange(cellBarcode = "BC1",
                                 co_count = s1_counts)
  expect_true(is(co_ranges,"GRanges"))
  expect_true(GenomicRanges::start(co_ranges)==3201)

  expect_true(as.character(GenomicRanges::seqnames(co_ranges))=="chr1")
  expect_true(GenomicRanges::end(co_ranges)=="5499")


})

#' \code{comapr} package
#'
#' crossover inference package
#'
#' See the README on
#'  \href{https://gitlab.svi.edu.au/biocellgen-private/comapr}{GitLab}
#'
#' @docType package
#' @name comapr

NULL

if(getRversion() >= "2.15.1") utils::globalVariables(c("."))

#' countCOs
#'
#' Count number of COs within each marker interval
#' COs identified in the interval overlapping missing markers are distributed
#' according to marker interval base-pair sizes. Genotypes encoded with "0" are
#' treated as missing value.
#'
#' @importFrom dplyr group_by lag
#' @importFrom dplyr %>%
#' @importFrom dplyr mutate
#' @importFrom foreach foreach
#' @importFrom foreach %dopar%
#' @importFrom BiocParallel bplapply
#' @importFrom rlang .data
#' @importFrom GenomicRanges GRanges seqnames mcols ranges seqinfo<- mcols<-
#' @importFrom GenomicRanges gaps granges
#' @importFrom IRanges mergeByOverlaps
#' @importFrom IRanges IRanges ranges start width
#' @importFrom S4Vectors from to
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment SummarizedExperiment

#' @export
#' @param geno GRanges object or RangedSummarizedExperiment object with genotype
#' matrix that has SNP positions in the rows and cells/samples in the columns

#' @return
#' GRanges object or RangedSummarizedExperiment with markers-intervals as rows
#' and samples in columns, values as the number of COs estimated for each marker
#' interval
#' @examples
#' data(twoSamples)
#' cocount <- countCOs(twoSamples)
#' @author Ruqian Lyu

setGeneric("countCOs",function(geno)
  standardGeneric("countCOs"))

#'@rdname countCOs
setMethod("countCOs",signature = c(geno="GRanges"),function(geno){
  countCOs_gr(geno)
})

#'@rdname countCOs
setMethod("countCOs",signature = c(geno="RangedSummarizedExperiment"),
          function(geno){
            geno_gr <- rowRanges(geno)
            mcols(geno_gr) <- as.matrix( assays(geno)[["vi_state"]])
            colnames(mcols(geno_gr)) <- as.character(colData(geno)$barcodes)
            result_gr <- countCOs_gr(geno_gr)
            stopifnot(colData(geno)$barcodes==colnames(mcols(result_gr)))
            SummarizedExperiment(assays=list(co_count=mcols(result_gr)),
                                 colData = colData(geno),
                                 rowRanges =granges(result_gr) )
})

#'countCOs_gr
#'
#'count number of crossovers for ranges in the input GRanges object
#'
#'@keywords internal
#'@noRd
#'
countCOs_gr <- function(geno) {
  stopifnot(!is.null(seqnames(geno)))

  crossover_counts <- bplapply(mcols(geno),
    FUN = function(sid_geno, snp_gr = geno[, 0]) {
      gps_snp_gr <- gaps(snp_gr)

      temp_df <-
        data.frame(
          chr = as.character(seqnames(snp_gr)),
          Pos = start(ranges(snp_gr)),
          GT = as.character(sid_geno),
          stringsAsFactors = FALSE
        )
      to_re <-
        temp_df %>% filter((!is.na(.data$GT)) &
                                    (!.data$GT ==
                                       "0")) %>%
        group_by(.data$chr) %>%
        mutate(CO = (.data$GT != lag(.data$GT)),
                      Prev = lag(.data$Pos)) %>%
        filter(.data$CO) %>% mutate(coid = cumsum(.data$CO))

      if (nrow(to_re) == 0) {
        ## no crossovers
        mcols(gps_snp_gr)$crossovers <- 0
      } else {
        co_gr <- GRanges(
          seqnames = to_re$chr,
          ranges = IRanges(start = to_re$Prev,
                           end = to_re$Pos -
                             1),
          coid = to_re$coid
        )

        myHits <- findOverlaps(gps_snp_gr, co_gr)

        co_gap_length <- width(ranges(gps_snp_gr))[from(myHits)] + 1
        len_prop <- (co_gap_length)/(width(ranges(co_gr))[to(myHits)])

        mcols(gps_snp_gr)$crossovers <- 0
        mcols(gps_snp_gr)$crossovers[from(myHits)] <- len_prop
      }
      gps_snp_gr
    }
  )
  final_df <- lapply(crossover_counts, mcols)
  final_df <- do.call(cbind,final_df)
  colnames(final_df) <- names(crossover_counts)

  co_gr <- crossover_counts[[1]]
  mcols(co_gr) <- final_df
  sort(co_gr)
  co_gr[width(ranges(co_gr)) != 0 &
          rowSums(as.matrix(final_df))>0, ]

}

#' countGT
#'
#' count how many samples have genotypes calls across markers and count how
#' many markers that each individual has called genotypes for. This function
#' helps identify poor samples or poor markers for filtering. It can also generate
#' plots that help identify outlier samples/markers
#'
#' @importFrom plotly plot_ly subplot
#' @importFrom gridExtra grid.arrange
#' @importFrom rlang .data
#' @author Ruqian Lyu
#'
#' @param geno the genotype data.frame of markers by samples from output of
#' function \code{correctGT}
#'
#' @param plot, it determines whether a plot will be generated, defaults to TRUE
#' @param interactive, it determines whether an interactive plot will be generated
#'
#' @export
#' @examples
#' data(snp_geno_gr)
#' genotype_counts <- countGT(GenomicRanges::mcols(snp_geno_gr))

#' @return
#' A list of two elements including \code{n_markers} and \code{n_samples}

countGT <- function(geno, plot =TRUE,interactive=FALSE){
  n_samples <- rowSums(!is.na(geno))
  n_markers <- colSums(!is.na(geno))
  counts <- type <- NULL
  pl_df <- data.frame(counts=c(n_samples,n_markers),
                      type = c(rep("by_marker", each = length(n_samples)),
                               rep("by_sample", each= length(n_markers))))
  type_colors <- c("by_marker"="#003f5c",
                   "by_sample"="#ffa600")
  if(plot){
    if(interactive){
      p <- plot_ly(data =pl_df,
                   x = ~type,y = ~counts, hoverinfo="text", jitter = 0.3,
                   boxpoints = "outliers",color = ~type,
                   text = ~paste('</br> counts ID: ',counts),
                      type = c("box"))

      return(list(ply = p,n_samples = rowSums(!is.na(geno)),
                  n_markers = colSums(!is.na(geno))))

    } else {

      p <- ggplot(data = pl_df,mapping = aes(y = counts,x = type))+
        geom_boxplot(size=1.5,aes(fill=type),alpha = 0.5)+
        geom_jitter(position = "jitter",aes(color=type),size=2,alpha=.8 )+
        theme_classic(base_size=22)+facet_wrap(.~type,scales = "free")+
        ylab("Number of samples/markers")+
        scale_color_manual(values=type_colors)+
        scale_fill_manual(values=type_colors)

    }
    return(list(plot = p,
                n_samples = rowSums(!is.na(geno)),
                n_markers = colSums(!is.na(geno))))
  }

  return(list(n_samples = rowSums(!is.na(geno)),
              n_markers = colSums(!is.na(geno))))
}

#' filterGT
#'
#' Filter markers or samples that have too many missing values
#'
#' @inheritParams countGT
#'
#' @param min_markers the minimum number of markers for a sample to be kept
#' @param min_samples the minimum number of samples for a marker to be kept
#'
#' @details
#' This function takes the \code{geno} data.frame and filter the data.frame by
#' the provided cut-offs.
#'
#' @author Ruqian Lyu
#'
#' @return
#' The filtered genotype matrix
#'
#' @examples
#' data(snp_geno_gr)
#' corrected_geno <- filterGT(snp_geno_gr, min_markers = 30,min_samples = 2)
#'
#' @export
#'
filterGT <- function(geno, min_markers = 5, min_samples = 3){

  gt_counts <- countGT(geno,plot = FALSE)
  keep_markers <- gt_counts$n_samples >= min_samples
  keep_samples <- gt_counts$n_markers >= min_markers

  message("filter out ",sum(keep_markers==FALSE)," marker(s)")
  message("filter out ",sum(keep_samples==FALSE)," sample(s)")

  return(geno[keep_markers, keep_samples])

}
setGeneric("filterGT")

#' @rdname filterGT
setMethod("filterGT",signature = c(geno ="matrix",min_markers = "numeric",
                                   min_samples = "numeric"),
          function(geno ,min_markers,
                   min_samples){
            filterGT(geno ,min_markers,
                     min_samples)

})

#' @rdname filterGT
setMethod("filterGT",signature = c(geno ="GRanges",min_markers = "numeric",
                                   min_samples = "numeric"),
          function(geno ,min_markers,
                   min_samples){

            gt_counts <- countGT(mcols(geno),plot = FALSE)
            keep_markers <- gt_counts$n_samples >= min_samples
            keep_samples <- gt_counts$n_markers >= min_markers
            geno <- geno[keep_markers,]

            mcols(geno) <- mcols(geno)[,keep_samples]
            message( "filter out ",sum(keep_markers==FALSE),
                            " marker(s)")
            message( "filter out ",sum(keep_samples==FALSE),
                            " sample(s)")

            return(geno)

          })

#' Plot markers with missing genotypes, deprecate
#'
#' @author Ruqian Lyu
#'
#' @param geno the genotype data.frame of markers by samples
#' @param plot_wg
#' whether to plot all markers across whole genome or just the markers that are
#' ever missing across all samples
#' @param missing
#' the label in the matrix that is used for encoding the missing or failed data
#' @param plot_type
#' whether a 'dot' plot or a 'bar' plot should be drawn
#'
#' @details
#' This functions plots the missing markers in a 'dot' plot or 'bar' plot.
#'
#' @import ggplot2
#' @importFrom dplyr filter
#' @importFrom dplyr group_by
#' @importFrom dplyr summarise
#'
#' @keywords internal
#' @noRd
#' @return
#' a ggplot2 object for markers with missing genotype across samples
#'
#' @examples
#' or_geno <-snp_geno[,grep("X",colnames(snp_geno))]
#' rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
#' cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
#'                     alt = snp_geno$FVB.NJ..i.,
#'                     chr = snp_geno$CHR)
#' plotMissingGT(cr_geno)


plotMissingGT <- function(geno, missing = "Fail", plot_wg = FALSE,
                          plot_type = "dot"){

  stopifnot(plot_type == "dot" | plot_type == "bar")


  mis_matrix <- apply(geno, 2, function(es){
    is.na(es) | es == missing
  })

  plot_df <- melt(mis_matrix)

  if(plot_wg){
    switch (plot_type,
            dot = ggplot(data = plot_df)+
              geom_point(mapping =
                           aes_string(x = "Var1", colour = "value",
                                      y = "Var2"))+
              xlab("markers")+ylab("samples")+
              labs(colour = "is_missing")+
              scale_color_manual(values = c("TRUE" = "red",
                                            "FALSE"= "lightgrey"))+
              theme_classic()+theme(axis.text.x = element_text(angle = -90)),

            bar =  ggplot(data = plot_df)+
              geom_bar(mapping = aes_string( fill = "value", x = "Var1"))+
              xlab("markers")+ylab("samples")+
              labs(fill = "is_missing")+
              scale_fill_manual(values = c("TRUE" = "red",
                                           "FALSE"= "lightgrey"))+
              theme_classic()+theme(axis.text.x = element_text(angle = -90))

    )


  } else {
    remain_m <- plot_df %>% group_by(.data$Var1) %>%
      summarise(no_missing = sum(.data$value)) %>% filter(.data$no_missing >0)

    plot_df <- plot_df[plot_df$Var1 %in% remain_m$Var1,]
    switch (plot_type,
            dot = ggplot(data = plot_df)+
              geom_point(mapping =  aes_string(x = "Var1", colour = "value",
                                               y = "Var2"))+
              xlab("markers")+ylab("samples")+
              labs(colour = "is_missing")+
              scale_color_manual(values = c("TRUE" = "red",
                                            "FALSE"= "lightgrey"))+
              theme_classic()+theme(axis.text.x = element_text(angle = -90)),

            bar =  ggplot(data = plot_df)+
              geom_bar(mapping = aes_string( fill = "value", x = "Var1"))+
              xlab("markers")+ylab("samples")+
              labs(fill = "is_missing")+
              scale_fill_manual(values = c("TRUE" = "red",
                                           "FALSE"= "lightgrey"))+
              theme_classic()+theme(axis.text.x = element_text(angle = -90))

    )


  }
}

#' getAFTracks
#'
#'
#' Generate the raw alternative allele frequencies tracks for all cells in the
#' columns of provided `co_count`
#'
#' @inheritParams getCellAFTrack
#' @importFrom Matrix readMM
#' @importFrom Gviz DataTrack
#' @importFrom GenomicRanges start
#' @author Ruqian Lyu
#' @export
#' @return a list object, in which each element is a list of two items with the
#' cell's alternative allele frequency DataTrack and the called crossover ranges.
#' @examples
#' demo_path <- system.file("extdata",package = "comapr")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_counts <- countCOs(s1_rse_state)
#'
#' af_co_tracks <- getAFTracks(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1",
#'                                barcodeFile = file.path(demo_path,
#'                                                     "s1_barcodes.txt"),
#'                                co_count = s1_counts)
#'
getAFTracks <-  function(chrom = "chr1",
                         path_loc = "./output/firstBatch/WC_522/",
                         sampleName = "WC_522",
                         nwindow = 80,
                         barcodeFile,
                         co_count,
                         snp_track = NULL){
  whichCells <- .get_cell_idx(barcodeFile = barcodeFile, 
                              cellBarcode = colnames(co_count))
  
  dpMM <- .get_cells_mm(path_loc = path_loc,sampleName = sampleName, 
                        chrom = chrom, whichCell = whichCells, type = "total")
  altMM <- .get_cells_mm(path_loc = path_loc,sampleName = sampleName, 
                         chrom = chrom, whichCell = whichCells, type = "alt")
  
  af_data <- altMM/dpMM

  lapply(colnames(co_count), function(cell){
    ithCell <- match(cell,colnames(co_count))
    cell_af <- af_data[,ithCell]
    keep_snp <- !is.na(cell_af)
    snp_pos  <- .get_snp_pos(snp_track = snp_track, path_loc = path_loc,
                 sampleName = sampleName, chrom = chrom)
    
    .get_af_track_and_co(chrom = chrom, snp_pos = snp_pos, 
                           keep_snp = keep_snp, cellBarcode = cell, 
                           af_data = cell_af,
                           nwindow = nwindow ,co_count = co_count)

  })

}

#' getDistortedMarkers
#'
#' Marker segregation distortion detection using chisq-test
#'
#' @details
#' We expect the genotypes to appear with the frequencies of 1:1 homo_alt:hets.
#' We usechisq.test for finding markers that have genotypes among samples that
#' are significantly different from the 1:1 ratio and report them
#' @param p the expected geneotype ratio in a numeric vector, defaults to c(0.5,0.5)
#' @param adj.method Methods to adjust for multiple comparisons, defaults to "BH"
#' @importFrom stats chisq.test p.adjust
#' @inheritParams countGT
#' @author Ruqian Lyu
#' @return data.frame with each row representing one SNP marker and columns
#' containing the chisq.test results
#' @examples
#' data(parents_geno)
#' data(snp_geno_gr)
#' corrected_geno <- correctGT(gt_matrix = GenomicRanges::mcols(snp_geno_gr),
#' ref = parents_geno$ref,alt = parents_geno$alt,fail = "Fail",
#' wrong_label = "Homo_ref")
#' GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
#' corrected_geno <- filterGT(snp_geno_gr, min_markers = 30,min_samples = 2)
#' pvalues <- getDistortedMarkers(GenomicRanges::mcols(corrected_geno))
#' @export

getDistortedMarkers <- function(geno, p = c(0.5,0.5),adj.method="BH"){
  geno_table <-
    vapply(seq_len(nrow(geno)), function(nthRow){
    list(Het = ifelse(is.na(table(unlist(geno[nthRow,]),useNA = "no")["Het"]),
                      0,
                      table(unlist(geno[nthRow,]),useNA = "no")["Het"]),
         Homo_alt = ifelse(is.na(table(unlist(geno[nthRow,]),
                                       useNA = "no")["Homo_alt"]),
                           0,
                           table(unlist(geno[nthRow,]),
                                 useNA = "no")["Homo_alt"]))
    },FUN.VALUE = vector(mode = "list",length = 2))

  geno_table <- data.frame(Markers = seq_len(ncol(geno_table)),
                           No.Hets =  as.character(unlist(geno_table["Het",])),
                           No.Homo_alt =
                             as.character(unlist(geno_table["Homo_alt",])),
                           stringsAsFactors = FALSE)

  pvals <- vapply(seq_len(nrow(geno_table)), function(marker){
    ctest <- chisq.test(as.numeric(geno_table[marker,2:3]),
                        p = p)
    ctest$p.value
  }, FUN.VALUE = numeric(1))
  geno_table$Pvals <- pvals
  geno_table$Adj.pvals <- p.adjust(pvals, method = adj.method)

  return(geno_table[order(geno_table$Adj.pvals),])
}

#' readHapState
#'
#' A function that parses the viterbi state matrix (in .mtx format),
#' barcode.txt and snpAnno.txt files for each individual.
#'
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment colData assay assay<- SummarizedExperiment
#' @importFrom SummarizedExperiment rowRanges metadata<- assays assays<-
#' @importFrom Matrix readMM
#' @importFrom utils read.table

#' @param path, the path to the files, with name patterns *{chrom}_vi.mtx,
#' *{chrom}_viSegInfo.txt, end with slash
#' @param barcodeFile, if NULL, it is assumed to be in the same directory as the
#' other files and with name sampleName_barcodes.txt
#' @param chroms, the character vectors of chromosomes to parse. Multiple chromosomes'
#' results will be concated together.
#' @param sampleName, the name of the sample to parse which is used as prefix for
#' finding relevant files for the underlying sample
#' @param bpDist, the crossover(s) will be filtered out if introduced by a segment
#'that is shorter than `bpDist` basepairs. It can be a single value or a vector
#'that is the same length and order with `chroms`.
#' @inheritParams .filterCOsExtra
#' @return a RangedSummarizedExperiment with rowRanges as SNP positions that
#' contribute to crossovers in any cells. colData contains cells annotation
#' including barcodes and sampleName.
#'
#' @examples
#' demo_path <- system.file("extdata",package = "comapr")
#' s1_rse_state <- readHapState(sampleName="s1",chroms=c("chr1"),
#' path=paste0(demo_path,"/"),
#' barcodeFile=NULL,minSNP = 0, minlogllRatio = 50,
#' bpDist = 100,maxRawCO=10,minCellSNP=3)
#' s1_rse_state
#' @export
#' @author Ruqian Lyu
#'

readHapState <- function(sampleName, chroms=c("chr1"), path,
                         barcodeFile = NULL, minSNP = 30,
                         minlogllRatio = 200,
                         bpDist = 100, maxRawCO = 10,nmad = 1.5,
                         minCellSNP = 200,
                         biasTol = 0.45){
  if(is.null(barcodeFile)){
    barcodeFile <- file.path(path,paste0(sampleName,"_barcodes.txt"))
  }

  bpDist <- .nameFeatures(chroms,bpDist)
  minSNP <- .nameFeatures(chroms,minSNP)
  minCellSNP <- .nameFeatures(chroms,minCellSNP)
  minlogllRatio <- .nameFeatures(chroms,minlogllRatio)

  result_fun <- function(){
      bpl_fun <- function(chr){

      barcodes <- read.table(file=barcodeFile,stringsAsFactors = FALSE,
                             col.names = "barcodes")
      snpAnno <- read.table(file=file.path(path,paste0(sampleName,"_",chr,
                                                       "_snpAnnot.txt")),
                            stringsAsFactors = FALSE,
                            header=TRUE)
      segInfo <- read.table(file = file.path(path,paste0(sampleName,"_",chr,
                                          "_viSegInfo.txt")),
                            stringsAsFactors = FALSE,
                            col.names = c("ithSperm","Seg_start","Seg_end",
                                          "logllRatio","nSNP","State"))
      vi_mtx <- readMM(file = file.path(path,paste0(sampleName,"_",
                                                    chr,"_vi.mtx")))
      grrange <- GRanges(seqnames = chr,
                         ranges = IRanges( start =  snpAnno$POS,
                                                    width = 1))
      se <- SummarizedExperiment(assays =
                                   list(vi_state = vi_mtx),
                                 colData = barcodes,
                                 rowRanges = grrange,
                                 metadata = data.frame(
                                   segInfo, chr=chr,
                                   sampleGroup=sampleName))
      se <- .filterCOsExtra(se , minSNP = minSNP[chr],
                            minlogllRatio = minlogllRatio[chr],
                            minCellSNP = minCellSNP[chr],
                            bpDist = bpDist[chr],
                            maxRawCO=maxRawCO,
                            biasTol=biasTol,
                            nmad=nmad)
      se
    }
    bplapply(chroms,function(chr) bpl_fun(chr))
  }

  se_list <- result_fun()

  rbind_se <- function(se1,se2){
    cc <- intersect(colnames(se1),colnames(se2))
    ## rbind does not combined the metadata, so
    rbind(se1[,cc],se2[,cc])
  }
  suppressWarnings(Reduce(rbind_se,se_list))
}

#'Filter out doublet cells and uninformative SNPs
#'
#'This function filter out cells that have been called too many crossovers due
#'to diploid cell contamination or doublets. It also only keeps SNPs (rows) that
#'ever contribute to a crossover interval. This function should be run for
#'individual chromosomes and is called internaly by `readHapState`

#'@param se, the SummarizedExperiment object that contains the called haplotype
#'state matrix in the assay field and haplotype segment information in the metadata
#'field.
#'@param maxRawCO, if a cell has more than `maxRawCO` number of raw crossovers
#'called across a chromosome, the cell is filtered out
#'@param minSNP, the crossover(s) will be filtered out if introduced by a segment
#'that has fewer than `minSNP` SNPs to support.
#'@param bpDist, the crossover(s) will be filtered out if introduced by a segment
#'that is shorter than `bpDist` basepairs.
#'@param minlogllRatio, the crossover(s) will be filtered out if introduced by a
#'segment that has lower than `minlogllRatio` to its reversed state.
#'@param minCellSNP, the minimum number of SNPs detected for a cell to be kept,
#'used with `nmads`
#'@param biasTol, the SNP's haplotype ratio across all cells is assumed
#'to be 1:1. This argument can be used for removing SNPs that have a biased
#'haplotype. i.e. almost always inferred to be haplotype state 1. It specifies
#'a bias tolerance value, SNPs with haplotype ratios deviating from 0.5 smaller
#'than this value are kept. Only effective when number of cells are larger than
#'10
#'
#'@param nmad, how many mean absolute deviations lower than the median number
#'of SNPs per cellfor a cell to be considered as low coverage cell and filtered
#'Only effective when number of cells are larger than 10. When effective, this or
#'`minCellSNP`, whichever is larger, is applied
#'
#'@importFrom Matrix Matrix
#'@importFrom SummarizedExperiment metadata<- assay<- colData rowRanges rowRanges<-
#'@importFrom S4Vectors metadata
#'@importFrom IRanges ranges
#'@importFrom stats mad median
#'@importFrom S4Vectors elementMetadata from to
#'@return A `RangedSummarizedExperment` object that have different dims with input.
#'the colnames are the cell barcodes, rowRanges specify the location of SNPs that
#'contribute to crossovers.
#'@details The `logllRatio` value is returned by `sgcocaller` for each haplotype
#'segment formed by consecutive SNPs that are called to have a same state. It is
#'calculated by taking log of ratio (likelihood of SNPs with inferred states)
#'and (likelihood of SNPs with reversed states)
#'
#'@author Ruqian Lyu
#'@keywords internal

.filterCOsExtra <- function(se,minSNP = 30, minlogllRatio = 200,
                            minCellSNP = 200,
                            bpDist = 100,
                            maxRawCO = 10,
                            biasTol = 0.45,
                            nmad = 1.5){
  total_SNP <- total_co <- barcode <- nSNP <- NULL
  segInfo <- data.frame(S4Vectors::metadata(se),stringsAsFactors = FALSE)

  segInfo$bp_dist <- segInfo$Seg_end - segInfo$Seg_start
  # ithSperm counts from 0. thus +1
  ithBC <- as.numeric(gsub("ithSperm","",segInfo$ithSperm))+1
  segInfo$barcode <- colData(se)$barcodes[ithBC]


  suppressMessages(
    rmCells <- segInfo %>% group_by(barcode) %>%
      summarise(total_SNP = sum(nSNP),
                       total_co = length(nSNP)-1))
  ## provided minCellSNP or nmads smaller from median, whichever is larger
  madsAway <- nmad*mad(rmCells$total_SNP)
  ## when there are more than 10 cells
  if(ncol(se) > 10 ){
    minCellSNP <- ifelse((median(rmCells$total_SNP) - madsAway) < minCellSNP,
                         minCellSNP, (median(rmCells$total_SNP) - madsAway))

  }

  ## Get the cell barcodes that are poor quality (doublets/low cov)
  rmCells <- rmCells %>%
    filter(total_co >= maxRawCO | total_SNP <= minCellSNP )

  rmCells <-  unique(rmCells$barcode)

  segInfo_f <- segInfo[!segInfo$barcode %in% rmCells
                       & segInfo$nSNP > minSNP
                       & segInfo$logllRatio > minlogllRatio
                       & segInfo$bp_dist > bpDist,]

  ## get Crossover contributing SNPs only
  co_contr_snp <- unique(c(segInfo_f$Seg_end,segInfo_f$Seg_start))
  co_contr_snp <- co_contr_snp[order(co_contr_snp)]

  ## remove some SNPs if their inferred states are biased
  markers <- co_contr_snp
  queryR <-  IRanges(start = markers,
                              width = 1)
  if(length(unique(segInfo_f$ithSperm)) > 10 ){

    markers_states <- lapply(unique(segInfo_f$ithSperm),function(ithS){
      subjectR <- IRanges(start = segInfo_f[segInfo_f$ithSperm==ithS,]$Seg_start,
                          end = segInfo_f[segInfo_f$ithSperm==ithS,]$Seg_end,
                          state = segInfo_f[segInfo_f$ithSperm==ithS,]$State)

      temp <- rep(0,length(markers))
      myHits <- findOverlaps(queryR,subjectR)
      temp[from(myHits)] <- elementMetadata(subjectR)$state[to(myHits)]
      temp
    })
    markers_states <- do.call(cbind,markers_states)

    ratio <- rowSums(markers_states==1)/(rowSums(markers_states==2) +
                                           rowSums(markers_states==1))

    co_contr_snp <- markers[abs(ratio-0.5) < biasTol]

  }
  ## row numbers of these SNPs in the assay
  ithSNP <- match(co_contr_snp, start(ranges(rowRanges(se ))))

  ## subset the columns to only keep the Good cells
  colnames(se) <- colData(se)$barcodes
  se <- se[ithSNP,colnames(se) %in% segInfo_f$barcode]
  
  vi_m <- Matrix(data=0,nrow=nrow(se),ncol=ncol(se))
  queryR <- IRanges(start=co_contr_snp,
                             width=1)

  ##<<<<<----UPDATE,TEST--------->>>>
  vi_m <- vapply(colnames(se),function(bc){
    nthCol <- which(colnames(se)==bc)
    segs <- segInfo_f[segInfo_f$barcode==bc,]
    temp <- rep(0,length(co_contr_snp))
    mthrows <- match(co_contr_snp,as.numeric(segs[,"Seg_start"]))
    temp[!is.na(mthrows)] <- segs[,"State"][mthrows[!is.na(mthrows)]]
    mthrows <- match(co_contr_snp,as.numeric(segs[,"Seg_end"]))
    temp[!is.na(mthrows)] <- segs[,"State"][mthrows[!is.na(mthrows)]]
    temp
  },numeric(nrow(se)))
  vi_m <- Matrix(vi_m,sparse = TRUE)
  assays(se)[["vi_state"]] <- vi_m
  metadata(se) <- segInfo_f
  se
}

#' Name the feature by chromosome names so that filtering of segments can use
#' chromosome specific values
#' @keywords internal
#' @noRd
#'
.nameFeatures <- function(chroms,featureVector){
  if(length(featureVector)!=1){
    stopifnot(length(featureVector) == length(chroms))
  } else{
    featureVector <- rep(featureVector,length(chroms))
  }
  names(featureVector) <- chroms
  featureVector
}

test_that("readHapState from raw files works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  sampleName <- "s1"
  s1_rse_state <- readHapState(sampleName,
                               chroms=c("chr1"),
                               path=demo_path,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               barcodeFile=NULL,
                               minSNP = 0,
                               minCellSNP = 1)

  expect_true(length(GenomeInfoDb::seqlevels(rowRanges(s1_rse_state))) ==1)

  s1_rse_state <- readHapState(sampleName,chroms=c("chr1"),
                               path=demo_path,
                               barcodeFile=paste0(demo_path,"s1_barcodes.txt"),
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)
  expect_true(length(GenomeInfoDb::seqlevels(rowRanges(s1_rse_state))) ==1)

  s1_rse_state <- readHapState(sampleName,chroms=c("chr1","chr2"),
                               path=demo_path,
                               barcodeFile=paste0(demo_path,"s1_barcodes.txt"),
                               minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,
                               maxRawCO=10,
                               minCellSNP = 1)
  expect_true(length(GenomeInfoDb::seqlevels(rowRanges(s1_rse_state))) ==2)



})


test_that("readHapState from raw files works for multiple filters", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  sampleName <- "s1"

  s1_rse_state <- readHapState(sampleName,chroms=c("chr1","chr2"),
                               path=demo_path,
                               barcodeFile=paste0(demo_path,"s1_barcodes.txt"),
                               minSNP = c(0,0),
                               minlogllRatio = c(50,49),
                               bpDist = c(100,99.1),
                               maxRawCO=10,
                               minCellSNP = 1)
  expect_true(length(GenomeInfoDb::seqlevels(rowRanges(s1_rse_state))) ==2)



})

test_that("combineHapState works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,barcodeFile=NULL,minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,maxRawCO=10,
                               minCellSNP = 0)
  
  s2_rse_state <- readHapState("s2",chroms=c("chr1","chr2"),
                               path=demo_path,
                               barcodeFile=paste0(demo_path,"s2_barcodes.txt"),minSNP = 0, 
                               minlogllRatio = 50,
                               bpDist = 100,maxRawCO=10,
                               minCellSNP = 0)
  sb <- combineHapState(s1_rse_state,s2_rse_state)
  expect_true(dim(sb)[2] == (dim(s1_rse_state) + dim(s2_rse_state))[2])
  
  expect_true(sum(colnames(sb) == c(colnames(s1_rse_state),
                                    colnames(s2_rse_state)))==dim(sb)[2] )
  
})

test_that("countCOs works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                               path=demo_path,barcodeFile=NULL,minSNP = 0,
                               minlogllRatio = 50,
                               bpDist = 100,maxRawCO=10,
                               minCellSNP = 0)
  count_rse <- countCOs(s1_rse_state)
  ## colsums for each cell is either 0 or 1
  expect_true(sum(colSums( as.matrix(assay(  count_rse))) !=0 & 
                    colSums( as.matrix(assay(  count_rse)))!=1)==0)
})

#' Calculate differences in genetic distances
#' @noRd
#' @keywords internal
.get_group_diff <- function(g1_index,g2_index,count_matrix,mapping_fun){
  
  rb_rate1 <- rowMeans(count_matrix[,g1_index])
  dist_1 <- .rb_to_dist(rb_rate1,mapping_fun=mapping_fun)
  
  rb_rate2 <- rowMeans(count_matrix[, g2_index])
  dist_2 <- .rb_to_dist(rb_rate2,mapping_fun=mapping_fun)
  
  sum(dist_1) - sum(dist_2)
}
#' bootstrapDist
#'
#' Generating distribution of sample genetic distances
#'
#' It takes the crossover counts for samples in multiple groups that is returned
#' by `countCO`. It then draws samples from a group with replacement and
#' calculate the distribution of relevant statistics.
#'
#' @param co_gr GRanges or RangedSummarizedExperiment object that contains the
#' crossover counts for each marker interval across all samples.
#' Returned by \code{countCOs}
#' @param mapping_fun character default to "k" (kosambi mapping function). It
#' can be one of the mapping functions: "k","h"
#' @param B integer the number of sampling times
#' @param group_by, the prefix for each group that we need to generate
#' distributions for(only when co_gr is a GRanges object). Or the column name
#' for `colData(co_gr)` that contains the
#' group factor (only when co_gr is a RangedSummarizedExperiment object)

#' @importFrom BiocParallel bplapply
#' @export
#' @return lists of numeric genetic distances for multiple samples
#' @examples
#' data(coCount)
#'
#' bootsDiff <- bootstrapDist(coCount, group_by = "sampleGroup",B=10)
#' @author Ruqian Lyu
#'
bootstrapDist <- function(co_gr, B = 1000, mapping_fun = "k", group_by )
{
  .check_mapping_fun(mapping_fun)
  count_m_idex <- .get_count_matrix(co_gr_rse = co_gr, group_by = group_by )
  result_fun <- function(){

    bpl_fun <- function(b) {
      boots_sample1 <- sample(unlist(count_m_idex$gi[1]),replace = TRUE)
      boots_sample2 <- sample(unlist(count_m_idex$gi[2]),replace = TRUE)

      .get_group_diff(g1_index = boots_sample1, g2_index = boots_sample2,
                      count_matrix = count_m_idex$c, mapping_fun = mapping_fun)
    }
    bplapply(seq_len(B), function(b) bpl_fun(b) )
  }
  boots_result <- result_fun()
  unlist(boots_result)
}


#' permuteDist
#'
#' Permutation test of two sample groups
#'
#' It shuffles the group labels for the samples and calculate a difference
#' between two groups after shuffling.
#'
#' @inheritParams bootstrapDist
#' @importFrom BiocParallel bplapply

#' @export
#' @return A list of three elements. `permutes` of length B with numeric
#' differences of permuted group differences,`observed_diff` the observed
#' genetic distances of two groups, `nSample`, the number of samples in the
#' first and second group.
#' @examples
#' data(coCount)
#' perms <- permuteDist(coCount, group_by = "sampleGroup",B=10)
#' @author Ruqian Lyu
#'
permuteDist <- function(co_gr,B=100,mapping_fun="k",group_by){
  .check_mapping_fun(mapping_fun)
  count_m_idex <- .get_count_matrix(co_gr_rse = co_gr, group_by = group_by )
  group_idx <- count_m_idex$gi
  
  stopifnot(length(group_idx)==2)
  two_g_idx <- unlist(group_idx)
  len_1 <- length(group_idx[[1]])
  ## there is a potential issue here.
  ## when the randomly generated "samples" have co_rate >0.5.
  ## Currently just abandon these trials
  result_fun <- function(){
    bpl_fun <- function(b){
      g1_idx <- sample(two_g_idx,size = len_1,replace = FALSE)
      g2_idx <- setdiff(two_g_idx,g1_idx)

      .get_group_diff(g1_index = g1_idx, g2_index = g2_idx,
                      count_matrix = count_m_idex$c, mapping_fun = mapping_fun)
    }
    bplapply(seq_len(B),function(b) bpl_fun(b))
  }
  
  perm_result <- result_fun()
  ## calculate observed diff
  g1_idx <- group_idx[[1]]
  g2_idx <- group_idx[[2]]

  observed_diff <- .get_group_diff(g1_index = g1_idx, g2_index = g2_idx,
                                   count_matrix = count_m_idex$c, 
                                   mapping_fun = mapping_fun)


  list(permutes=unlist(perm_result),
       observed_diff = observed_diff,
       nSample=c(length(g1_idx),length(g2_idx)))
}

#' Kosambi mapping function
#' @noRd
#' @keywords internal
.k_map <- function(rb_rate){
  25*log((1+2*rb_rate)/(1-2*rb_rate))
}
#' Haldane mapping function
#' @noRd
#' @keywords internal
.h_map <- function(rb_rate){
  -50 * log(1 - 2 * rb_rate)
}

.rb_to_dist <- function(rb_rate,mapping_fun){
  switch(mapping_fun,
         k = .k_map(rb_rate),
         h = .h_map(rb_rate))
}
#' Get the count matrix from RSE or Granges object's mcols
#' @noRd
#' @keywords internal
.get_count_matrix <- function(co_gr_rse,group_by){

  if(is(co_gr_rse,"RangedSummarizedExperiment")){
    count_matrix <- as.matrix(assay(co_gr_rse))
    group_idx <- lapply(unique(as.character(colData(co_gr_rse)[, group_by])),
                        function(gp) {
                          grep(gp, colData(co_gr_rse)[, group_by])})

  } else {
    ## co_gr is of GRanges class
    count_matrix <- as.matrix(mcols(co_gr_rse))
    group_idx <- lapply(group_by, function(gp){
      grep(gp,colnames(mcols(co_gr_rse)))
    })
  }
  list(c = count_matrix, gi = group_idx)
}

# test boostrap
data(snp_geno_gr)
data("parents_geno")
test_that("bootstrapDist works", {

  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  #  co_geno$interval_ID <- rownames(co_geno)
  # melt_geno <- melt(co_geno,id= 'interval_ID')
  # colnames(melt_geno) <- c("interval_ID","SampleID","Cross_over")
  marker_gr_cos <- countCOs(snp_geno_gr)

  # expect_equal(sum(marker_gr_cos[4:5,"X92"]$X92),1)
  # dist <- calGeneticDist(marker_gr_cos)
  # expect_true(abs(dist$kosambi_cm[4]-13.67603)<1e-3)
  #
  bootstrap_results <- suppressWarnings(bootstrapDist(marker_gr_cos,B=10,
                                                      group_by  = c("X1","X9")))
  expect_true(length(bootstrap_results)==10)
})

test_that("permuteDist works", {

  corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                              ref = parents_geno$ref,
                              alt = parents_geno$alt)
  GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
  #  co_geno$interval_ID <- rownames(co_geno)
  # melt_geno <- melt(co_geno,id= 'interval_ID')
  # colnames(melt_geno) <- c("interval_ID","SampleID","Cross_over")
  marker_gr_cos <- countCOs(snp_geno_gr)

  # expect_equal(sum(marker_gr_cos[4:5,"X92"]$X92),1)
  # dist <- calGeneticDist(marker_gr_cos)
  # expect_true(abs(dist$kosambi_cm[4]-13.67603)<1e-3)
  #
  perms_results <- suppressWarnings(permuteDist(marker_gr_cos,B=10,
                                                      group_by  = c("X1","X9")))
  expect_true(!is.null(perms_results$permutes))
  expect_true(!is.null(perms_results$observed_diff))
  expect_true(!is.null(perms_results$nSample))

})

#' Markers by genotype results for a group of samples
#'
#' @source Statistics Canada. Table 001-0008 - Production and farm value of
#'  maple products, annual. \url{http://www5.statcan.gc.ca/cansim/}
#' @format A data frame with columns:
#' \describe{
#'  \item{C57BL.6J}{genotype of reference mouse train across markers}
#'  \item{FVB.NJ..i.}{genotype of alternative mouse train across markers}
#'  \item{POS}{SNP marker base-pair location }
#'  \item{CHR}{SNP marker chromosome location}
#'  \item{X100}{a mouse sample }
#'  \item{X101}{a mouse sample }
#'  \item{X102}{a mouse sample }
#'  \item{X103}{a mouse sample }
#'  \item{X104}{a mouse sample }
#'  \item{X105}{a mouse sample }
#'  \item{X106}{a mouse sample }
#'  \item{X107}{a mouse sample }
#'  \item{X108}{a mouse sample }
#'  \item{X109}{a mouse sample }
#'  \item{X110}{a mouse sample }
#'  \item{X111}{a mouse sample }
#'  \item{X112}{a mouse sample }
#'  \item{X113}{a mouse sample }
#'  \item{X92}{a mouse sample }
#'  \item{X93}{a mouse sample }
#'  \item{X94}{a mouse sample }
#'  \item{X95}{a mouse sample }
#'  \item{X96}{a mouse sample }
#'  \item{X97}{a mouse sample }
#'  \item{X98}{a mouse sample }
#'  \item{X99}{a mouse sample }
#'  \item{rsID}{the SNP ID}
#' }
#' @usage data(snp_geno)
"snp_geno"

#' Markers by genotype results for a group of samples
#'
#' @source TBD
#' @format A GRanges object:
#' \describe{
#'  \item{X100}{a mouse sample }
#'  \item{X101}{a mouse sample }
#'  \item{X102}{a mouse sample }
#'  \item{X103}{a mouse sample }
#'  \item{X104}{a mouse sample }
#'  \item{X105}{a mouse sample }
#'  \item{X106}{a mouse sample }
#'  \item{X107}{a mouse sample }
#'  \item{X108}{a mouse sample }
#'  \item{X109}{a mouse sample }
#'  \item{X110}{a mouse sample }
#'  \item{X111}{a mouse sample }
#'  \item{X112}{a mouse sample }
#'  \item{X113}{a mouse sample }
#'  \item{X92}{a mouse sample }
#'  \item{X93}{a mouse sample }
#'  \item{X94}{a mouse sample }
#'  \item{X95}{a mouse sample }
#'  \item{X96}{a mouse sample }
#'  \item{X97}{a mouse sample }
#'  \item{X98}{a mouse sample }
#'  \item{X99}{a mouse sample }
#'  \item{rsID}{the SNP ID}
#' }
#' @usage data(snp_geno_gr)
#'
"snp_geno_gr"

#' Parents' genotype for F1 samples in `snp_geno`
#' @format A data.frame:
#' \describe{
#'  \item{C57BL.6J}{genotype of reference mouse train across markers}
#'  \item{FVB.NJ..i.}{genotype of alternative mouse train across markers}
#'}
#' @usage data(parents_geno)
"parents_geno"


#' RangedSummarizedExperiment object containing the Viterbi states SNP markers
#' for samples from two groups. `colData(twoSamples)` contains the sample group
#' factor.
#' @usage data(twoSamples)
"twoSamples"


#' RangedSummarizedExperiment object containing the crossover counts across
#' samples for the list of SNP marker intervals
#'
#' @usage data(coCount)
"coCount"

#' getCellAFTrack
#' Generates the DataTracks for plotting AF and crossover regions
#'
#' It plots the raw alternative allele frequencies and highlight the crossover
#' regions for the selected cell.
#' @param chrom, the chromosome
#' @param path_loc, the path prefix to the output files from sscocaller including
#' "*_totalCount.mtx" and "_altCount.mtx"
#' @param sampleName, the sample name, which is the prefix of sscocaller's output
#' files
#'
#' @param nwindow, the number of windows for binning the chromosome
#' @param barcodeFile, the barcode file containing the list of cell barcodes used
#' as the input file for sscocaller
#' @param cellBarcode, the selected cell barcode
#' @param snp_track, the SNP position track which is used for obtaining the SNP
#' chromosome locations. It could be omitted and the SNP positions will be acquired
#' from the "*_snpAnnot.txt" file.
#' @param co_count, `GRange` or `RangedSummarizedExperiment` object,
#' returned by \code{countCO} that contains the crossover intervals and the number
#' of crossovers in each cell.
#' @param chunk, An integer scalar indicating the chunk size to use,
#' i.e., number of rows to read at any one time.
#'
#' @return The DataTrack object defined in \code{\link[Gviz]{DataTrack}}
#' @importFrom  Gviz DataTrack
#' @author Ruqian Lyu
#' @export
#' @examples
#' demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_counts <- countCOs(s1_rse_state)
#' af_co_tracks <- getCellAFTrack(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1",
#'                                barcodeFile = paste0(demo_path,
#'                                                     "s1_barcodes.txt"),
#'                                cellBarcode = "BC1",
#'                                co_count = s1_counts)
#'
getCellAFTrack <-  function(chrom = "chr1",
                            path_loc = "./output/firstBatch/WC_522/",
                            sampleName = "WC_522",
                            nwindow = 80,
                            barcodeFile,
                            cellBarcode,
                            co_count,
                            snp_track = NULL,
                            chunk = 1000L){
  stopifnot(length(cellBarcode)==1)
 
  af_data <- .get_af_data(chrom = chrom, path_loc = path_loc, 
                          sampleName = sampleName, barcodeFile = barcodeFile,
                          cellBarcode = cellBarcode, co_count = co_count,
                          chunk = chunk)
  keep_snp <- !is.na(af_data)

  snp_pos <- .get_snp_pos(snp_track = snp_track, path_loc = path_loc,
                          sampleName = sampleName, chrom = chrom)

  .get_af_track_and_co(chrom = chrom, snp_pos = snp_pos, 
                       keep_snp = keep_snp, cellBarcode = cellBarcode, 
                       af_data = af_data,
                       nwindow = nwindow ,co_count = co_count)
}
#' Generate DataTrack and CO range in a list 
#' @noRd
#' @keywords internal
.get_af_track_and_co <- function(chrom, snp_pos, keep_snp, cellBarcode, af_data,
                                 nwindow,co_count){
  
  af_track <- DataTrack(GRanges(seqnames = chrom,
                                IRanges(start=snp_pos[keep_snp],
                                        width = 1)),
                        name = paste0(cellBarcode, " AF"),
                        data = af_data[keep_snp],
                        window = nwindow,
                        na.rm=TRUE,
                        aggregation = "mean",
                        type="p",
                        ylim=0:1)
  co_range_cell1 <- getCellCORange(co_count, cellBarcode = cellBarcode)
  co_range_cell1[seqnames(co_range_cell1)==chrom,]
  
  list(af_track = af_track, co_range = co_range_cell1)
}
#' 
#' Get cell(s) AF data
#' @noRd
#' @keywords internal
.get_af_data <- function( chrom, path_loc, sampleName, barcodeFile,
                          cellBarcode, co_count, chunk){
  
  whichCell <- .get_cell_idx(barcodeFile = barcodeFile,
                             cellBarcode = cellBarcode )

  dpMM <- .get_cells_mm(path_loc = path_loc, sampleName = sampleName,
                           chrom = chrom, whichCell = whichCell,
                           chunk = chunk,
                           type = "total") 
  altMM <- .get_cells_mm(path_loc = path_loc, sampleName = sampleName,
                             chrom = chrom, whichCell = whichCell,
                             chunk = chunk,
                             type = "alt") 
  af_data <- altMM/dpMM
  af_data
}

#' Find cell(s) index
#' @noRd
#' @keywords internal
#' 
.get_cell_idx <- function(barcodeFile,
                          cellBarcode){
  stopifnot(file.exists(barcodeFile))
  initial_barcodes <- read.table(file = barcodeFile)
  whichCell <- match(cellBarcode, initial_barcodes$V1)
  whichCell
}


#' Get cells total DP or alt counts
#' @noRd
#' @keywords internal
.get_cells_mm <- function(path_loc, sampleName,
                          chrom, whichCell,chunk = 1000L,
                          type = "total"){
  stopifnot(type %in% c("total","alt"))
  
  if(type == "total"){
    if(length(whichCell)>1){
      mm <- readMM(file = file.path(path_loc, paste0(sampleName, "_",
                                    chrom, "_totalCount.mtx")))
    } else {
      mm <- readColMM(file = file.path(path_loc, paste0(sampleName, "_",
                                  chrom, "_totalCount.mtx")),
                    which.col = whichCell,
                    chunk = chunk)
      }
    
  } else {
    if(length(whichCell)>1){
      mm <- readMM(file = file.path(path_loc, paste0(sampleName,"_",
                                    chrom,"_altCount.mtx")))
    }
    else{
      mm <- readColMM(file = file.path(path_loc, paste0(sampleName,"_",
                                  chrom,"_altCount.mtx")),
                    which.col = whichCell,
                    chunk = chunk)
    }

  }
  mm[,whichCell]
}

#' plotCount
#'
#' Plot the number of COs per sample group or per chromosome
#'
#' @param co_count
#' GRange or RangedSummarizedExperiment object, returned by \code{countCO}
#' @param group_by, the column name in `colData(co_count)` that specify the
#' grouping factor. Or the character vector contains the unique prefix of
#' sample names that are used for defining different sample groups. If missing
#' all samples are assumed to be from one group
#' @param by_chr, whether it should plot each chromosome separately
#' @param plot_type, determins what type the plot will be, choose from "error_bar"
#'  or "hist". Only relevant when by_chr=TRUE
#' @return ggplot object
#' @importFrom plyr mapvalues
#' @importFrom tidyr pivot_longer
#' @importFrom RColorBrewer  brewer.pal
#' @examples
#' demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_count <- countCOs(s1_rse_state)
#' plotCount(s1_count)
#' @export
#'

setGeneric("plotCount",
           function(co_count,
                    by_chr=FALSE,
                    group_by  = "sampleGroup",
                    plot_type="error_bar")
             standardGeneric("plotCount"))


#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'RangedSummarizedExperiment',
                                    by_chr='missing',
                                    group_by='missing',
                                    plot_type='ANY'),
          function(co_count, by_chr = FALSE, group_by, plot_type){
            co_count$sampleGroup <- "all"
            plot_count(co_count = co_count,group_by  = "sampleGroup",
                       by_chr = by_chr,plot_type=plot_type)


          })

#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'RangedSummarizedExperiment',
                                    by_chr='missing',
                                    group_by='character',
                                    plot_type='ANY'),
          function(co_count, by_chr = FALSE, group_by, plot_type){


              plot_count(co_count = co_count,group_by  = group_by,
                         by_chr = FALSE,plot_type=plot_type)



          })

#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'RangedSummarizedExperiment',
                                    by_chr='logical',
                                    group_by='character',
                                    plot_type='ANY'),
          function(co_count, by_chr = FALSE , group_by, plot_type){
            plot_count(co_count = co_count,group_by  = group_by,
                       by_chr = by_chr,plot_type=plot_type)

          })


#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'RangedSummarizedExperiment',
                                    by_chr='logical',
                                    group_by='missing',
                                    plot_type='ANY'),
          function(co_count, by_chr = FALSE, group_by, plot_type){
            co_count$sampleGroup <- "all"
            plot_count(co_count = co_count,group_by  = "sampleGroup",
                       by_chr = by_chr,plot_type=plot_type)

          })




#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'GRanges',
                                    by_chr='logical',
                                    group_by='missing',
                                    plot_type='ANY'),
          function(co_count, by_chr = FALSE, group_by, plot_type){
           tmp_counts <- SummarizedExperiment(rowRanges = granges(co_count),
                                 colData = data.frame(sampleGroup=rep("all",ncol(mcols(co_count)))),
                                 assays=list(co_count=mcols(co_count)))
            plot_count(co_count = tmp_counts,group_by  = "sampleGroup",
                       by_chr = by_chr,plot_type=plot_type)

          })

#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'GRanges',
                                    by_chr='missing',
                                    group_by='missing',
                                    plot_type='ANY'),
          function(co_count, by_chr, group_by, plot_type){
            tmp_counts <-  SummarizedExperiment(rowRanges = granges(co_count),
                                                colData = data.frame(
                                                  sampleGroup=rep("all",
                                                                  ncol(mcols(co_count)))),
                                                assays=list(co_count=mcols(co_count)))

            plot_count(co_count = tmp_counts,group_by  = "sampleGroup",
                       by_chr = FALSE,plot_type=plot_type)

          })
#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'GRanges',
                                    by_chr='missing',
                                    group_by='character',
                                    plot_type='ANY'),
          function(co_count, by_chr, group_by, plot_type){
            sampleGroup <- rep("all",ncol(mcols(co_count)))
            for(group_prefix in group_by){
              sampleGroup[grep(group_prefix,
                               colnames(mcols(co_count))) ] <- group_prefix
            }

            tmp_counts <- SummarizedExperiment(rowRanges = granges(co_count),
                                                colData = data.frame(sampleGroup=sampleGroup),
                                                assays=list(co_count=mcols(co_count)))
            plot_count(co_count = tmp_counts,group_by  = "sampleGroup",
                       by_chr = FALSE,plot_type=plot_type)

          })
#'@rdname plotCount
setMethod("plotCount",signature = c(co_count = 'GRanges',
                                    by_chr='logical',
                                    group_by='character',
                                    plot_type='ANY'),
          function(co_count, by_chr, group_by, plot_type="error_bar"){
            if(length(plot_type)==0){plot_type <- "error_bar"}

            sampleGroup <- rep("all",ncol(mcols(co_count)))
            for(group_prefix in group_by){
              sampleGroup[grep(group_prefix,
                               colnames(mcols(co_count))) ] <- group_prefix
            }

            tmp_counts <- SummarizedExperiment(rowRanges = granges(co_count),
                                               colData = data.frame(sampleGroup=sampleGroup),
                                               assays=list(co_count=mcols(co_count)))
            plot_count(co_count = tmp_counts,group_by  = "sampleGroup",
                       by_chr = by_chr,plot_type=plot_type)

          })
#'@noRd
plot_count <- function(co_count, by_chr=FALSE, group_by  = "sampleGroup",
                      plot_type=c("error_bar","hist") ){

  stopifnot(group_by %in% colnames(colData(co_count)))
  col_to_plot <- unique(colData(co_count)[,group_by])
  sample_group_colors <- brewer.pal(ifelse(length(col_to_plot)> 2,
                                                         length(col_to_plot),3),
                                                  name = "Set1")

  names(sample_group_colors)[seq_along(col_to_plot)] <- col_to_plot
  sample_group_colors <- sample_group_colors[seq_along(col_to_plot)]
  chr <- BC <- COs <- sampleGroup <- NULL
  ChrCOs <- meanCOs <- sd <- lower <- upper <- NULL
  if(by_chr){

    tmp <- assay(co_count)
    tmp$chr <- seqnames(co_count)
    tmp <- data.frame(tmp,check.names = FALSE) %>%
      pivot_longer(cols = colnames(co_count),
                          values_to = "COs", names_to = "BC")
    tmp$sampleGroup <- mapvalues(tmp$BC, from = colnames(co_count),
                                       to = colData(co_count)[,group_by])

    stopifnot(plot_type %in% c("error_bar","hist"))

    if(plot_type == "error_bar"){
      suppressMessages(
        p <- tmp %>% group_by(chr,BC) %>%
          summarise(ChrCOs = sum(COs),
                    sampleGroup = unique(sampleGroup)) %>%
          group_by(chr,sampleGroup) %>%
          summarise(meanCOs = mean(ChrCOs),
                           lower = meanCOs-sd(ChrCOs)/sqrt(length(ChrCOs)),
                           upper = meanCOs+sd(ChrCOs)/sqrt(length(ChrCOs))) %>%
          ggplot(mapping = aes(x=chr,y = meanCOs,
                               color=chr))+geom_point()+
          geom_errorbar(mapping = aes(ymin = lower,
                                      ymax = upper))+
          facet_wrap(.~sampleGroup)+
          theme_classic(base_size = 18))
    } else {
      suppressMessages(
        p <- tmp %>% group_by(chr,BC) %>%
          summarise(ChrCOs = sum(COs),
                    sampleGroup = unique(sampleGroup)) %>%
          group_by(chr,sampleGroup) %>%
          ggplot()+geom_histogram(mapping = aes(x=ChrCOs))+facet_wrap(.~chr))
    }
  } else {

    plt_df <- data.frame(COs = colSums(as.matrix(assay(co_count))),

                         sampleGroup = colData(co_count)[,group_by])
    p <- ggplot(data = plt_df,
                mapping = aes(x = sampleGroup, color = sampleGroup,
                              y = COs))+geom_boxplot()+
      geom_jitter(width = 0.2,
                  height = 0.0)+
      theme_classic(base_size = 16)+
      scale_color_manual(values = sample_group_colors)
  }
  p

}

#' getMeanDPTrack
#'
#' Generate the mean DP (Depth) DataTrack (from Gviz) for cells
#' @inheritParams getCellAFTrack
#' @importFrom Matrix rowMeans
#' @param log, whether the histogram of SNP density should be plotted on log
#' scale (log10)
#' @param plot_type, the DataTrack plot type, default to be `hist`
#' @param selectedBarcodes, the selected cell barcodes which should be the
#' barcodes that have been called crossovers for. If not supplied then all cells
#' are counted.
#'
#' @author Ruqian Lyu
#' @export
#' @return DataTrack object plotting the mean DP histogram for windowed
#' chromosomes
#'
#' @examples
#' demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
#' meanDP_track <- getMeanDPTrack(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1",
#'                                barcodeFile = paste0(demo_path,
#'                                                     "s1_barcodes.txt"))
#'
getMeanDPTrack <- function( chrom = "chr1",
                            path_loc,
                            nwindow = 80,
                            sampleName,
                            barcodeFile,
                            plot_type = "hist",
                            selectedBarcodes = NULL,
                            snp_track = NULL,
                            log =TRUE){
  initial_barcodes <- read.table(file = barcodeFile)


  dpMM <- readMM(file =paste0(path_loc,sampleName,"_",chrom,"_totalCount.mtx"))
  if(!is.null(selectedBarcodes))
  dpMM <- dpMM[,match(selectedBarcodes, initial_barcodes$V1)]

  meanDP <- rowMeans(dpMM)
  
  snp_pos <- .get_snp_pos(snp_track = snp_track, path_loc = path_loc,
               sampleName = sampleName, chrom = chrom)
  
  meanDP_track <- DataTrack(GRanges(seqnames = chrom,
                                     IRanges(start= snp_pos,
                                             width = 1,
                                             genome = "mm10")),
                             name = "meanDP across cells",
                             data = meanDP,window =nwindow,
                             aggregation = .aggregation_fun_log(log,"mean"),
                             type=plot_type,
                             background.panel = "#FFFEDB",
                             background.title = "lightblue")
  meanDP_track
}



#' getCellDPTrack
#' Generates the DataTrack for plotting DP of a selected cell
#'
#' It plots the total allele counts for the selected cell.
#' @inheritParams getCellAFTrack
#' @inheritParams getSNPDensityTrack
#' @param chrom, the chromosome
#' @param path_loc, the path prefix to the output files from sscocaller
#' including "*_totalCount.mtx"
#'
#' @param nwindow, the number of windows for binning the chromosome
#' @param barcodeFile, the barcode file containing the list of cell barcodes
#'  used as the input file for sscocaller
#' @param cellBarcode, the selected cell barcode
#' @param snp_track, the SNP position track which is used for obtaining the SNP
#' chromosome locations. It could be omitted and the SNP positions will be
#' acquired from the "*_snpAnnot.txt" file.
#' @param chunk, A integer scalar indicating the chunk size to use, i.e., number
#' of rows to read at any one time.

#' @return The DataTrack object defined in \code{\link[Gviz]{DataTrack}}
#' @importFrom  Gviz DataTrack
#' @author Ruqian Lyu
#' @export
#' @examples
#' demo_path <- system.file("extdata",package = "comapr")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 0)
#' s1_counts <- countCOs(s1_rse_state)
#' dp_co_tracks <- getCellDPTrack(chrom ="chr1",
#'                                path_loc = demo_path,
#'                                sampleName = "s1",
#'                                barcodeFile = file.path(demo_path,
#'                                                     "s1_barcodes.txt"),
#'                                cellBarcode = "BC1")
#'
getCellDPTrack <-  function(chrom = "chr1",
                            path_loc = "./output/firstBatch/WC_522/",
                            sampleName = "WC_522",
                            nwindow = 80,
                            barcodeFile,
                            cellBarcode,
                            snp_track = NULL,
                            chunk = 1000L,
                            log =TRUE,
                            plot_type = "hist"){
  stopifnot(length(cellBarcode)==1)
  whichCell <- .get_cell_idx(barcodeFile = barcodeFile, 
                            cellBarcode = cellBarcode) 

  dpMM <- .get_cells_mm(path_loc = path_loc, sampleName = sampleName,
                           chrom = chrom, whichCell = whichCell, chunk = chunk,
                           type = "total")
  snp_pos <- .get_snp_pos(snp_track = snp_track, path_loc = path_loc,
                          sampleName = sampleName, chrom = chrom)

  dp_track <- DataTrack(GRanges(seqnames = chrom,
                                      IRanges(start=snp_pos,
                                              width = 1,
                                              genome = "mm10")),
                              name = paste0(cellBarcode, " AF"),
                              data = dpMM,
                              window = nwindow,
                              na.rm=TRUE,
                              aggregation = .aggregation_fun_log(log,"mean"),
                              type=plot_type)

  dp_track
}

#' get aggregation function
#' @keywords internal
#' @noRd
#' 
.aggregation_fun_log <- function(log,fun = "mean"){
  stopifnot(fun %in% c("mean","sum"))
  if(fun == "mean"){
   if(log){
      function(x) { log10(mean(x)+1)}
    } else {
      mean
    }
  } else if(fun == "sum") {
    if(log){
      function(x) { log10(sum(x)+1)}
    } else {
      sum
    }
  } 
} 

#' get_snp_pos from track or snp_annot_file
#' @return a list of SNP positions for selected chromosome
#' @keywords internal
#' @importFrom GenomicRanges start
#' @noRd
.get_snp_pos <- function(snp_track = NULL,path_loc,sampleName,chrom){

  if(is.null(snp_track)){
    snp_anno <- read.table(file=file.path(path_loc,paste0(sampleName,"_",
                                       chrom, "_snpAnnot.txt")),
                           header=TRUE)
    snp_pos <- snp_anno$POS

  } else {
    stopifnot(unlist(dimnames(seqinfo(snp_track))) == chrom)
    snp_pos <- start(snp_track)
  }
  snp_pos
}

test_that("get Mean DP track works works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  meanDP_track <- getMeanDPTrack(chrom ="chr1",
                                 path_loc = demo_path,
                                 barcodeFile = paste0(demo_path,"s1_barcodes.txt"),
                                 sampleName = "s1")
  expect_silent(Gviz::plotTracks(meanDP_track))
})


test_that("get celll DP track works works", {
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
  bc1_dp_track <- getCellDPTrack(chrom ="chr1",
                                 path_loc = demo_path,
                                 barcodeFile = paste0(demo_path,"s1_barcodes.txt"),
                                 sampleName = "s1",
                                 chunk = 2,
                                 cellBarcode = "BC1",
                                 log = TRUE)
  expect_silent(Gviz::plotTracks(bc1_dp_track))
})

#' combineHapState
#'
#' combine two `RangedSummarizedExperiment` objects, each contains the haplotype
#' state for a list of SNPs across a set of cells. The combined result will have
#' cells from two individuals and merged list of SNPs from the two.
#'
#' @importFrom  Matrix Matrix
#' @importFrom IRanges findOverlaps IRanges
#' @importFrom SummarizedExperiment rowRanges assay assay<- rowRanges<-
#' @importFrom SummarizedExperiment assays assays<-
#' @importFrom S4Vectors merge from to 
#' @param rse1, the first `RangedSummarizedExperiment`
#' @param rse2, the second `RangedSummarizedExperiment`
#' @param groupName, a character vector of length 2 that contains the first and
#' the second group's names
#'
#' @examples
#' BiocParallel::register(BiocParallel::SnowParam(workers = 1))
#' demo_path <- paste0(system.file("extdata",package = "comapr"),"/")
#' s1_rse_state <- readHapState("s1",chroms=c("chr1"),
#'                              path=demo_path,barcodeFile=NULL,minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 1)
#'
#' s2_rse_state <- readHapState("s2",chroms=c("chr1"),
#'                              path=demo_path,
#'                              barcodeFile=paste0(demo_path,"s2_barcodes.txt"),
#'                              minSNP = 0,
#'                              minlogllRatio = 50,
#'                              bpDist = 100,maxRawCO=10,
#'                              minCellSNP = 1)
#' sb <- combineHapState(s1_rse_state,s2_rse_state)
#'
#' @return A `RangedSummarizedExperiment` that contains the cells and SNPs in
#' both `rse`
#'
#' @export
#'
#' @author Ruqian Lyu
#'
combineHapState <- function(rse1,rse2,
                             groupName=c("Sample1","Sample2")){

  stopifnot(length(groupName)==2)

  merged_anno <- S4Vectors::merge(rowRanges(rse1),rowRanges(rse2),all=TRUE)

  stopifnot(!is.data.frame(merged_anno))
  t <- Matrix(data=0,nrow=length(merged_anno),ncol=(ncol(rse1)+ncol(rse2)),
              sparse = TRUE)
  se1_rows <- findOverlaps(merged_anno,rowRanges(rse1),select = "all")
  se1_rows <- from(se1_rows)
  t[se1_rows,seq_len(ncol(rse1))] <- assays(rse1)[["vi_state"]]
  se2_rows <- findOverlaps(merged_anno,rowRanges(rse2),select = "all")
  se2_rows <- from(se2_rows)
  t[se2_rows,(ncol(rse1)+1):ncol(t)] <- assay(rse2)
  combinedCols <- rbind(colData(rse1),colData(rse2))


  SummarizedExperiment(assays=list(vi_state=t),
                         colData = combinedCols,
                         rowRanges = merged_anno)



}

#' check supplied mapping function is available
#' @param mapping_fun, the mapping function to use, one of c("k","h")
#' @noRd
.check_mapping_fun <- function(mapping_fun){
  if(!mapping_fun %in% c("k","h")){
    message("only Kosambi and Haldane mapping function are supported at current
            stage")
    quit()
  }

}
#' cal_marker_dist
#'
#' Covert the recombination rate to cM by mapping functions
#' @importFrom GenomicRanges mcols
#' @noRd
cal_marker_dist <- function(co_count,mapping_fun="k",group_by = NULL){
  ## just covert the recombination rate to cM by mapping functions

  new_gr <- co_count[,0]

  if(is.null(group_by)){
    co_rate <- rowMeans(as.matrix(mcols(co_count)))
    stopifnot(sum(co_rate>=0.5)==0)
    cm_dist <- .rb_to_dist(co_rate, mapping_fun=mapping_fun)

    switch(mapping_fun,
      k =     mcols(new_gr)$kosambi_cm <- cm_dist,
      h =     mcols(new_gr)$haldane_cm <- cm_dist)

  } else {
    ## group_by has the character of prefix of groups
     groups_rb <- bplapply(group_by,function(group_prefix,mapping_fun){
       sids <- grep(group_prefix,colnames(mcols(co_count)))
       co_rate <- rowMeans(as.matrix(mcols(co_count)[,sids]))
       cm_dist <- .rb_to_dist(co_rate, mapping_fun=mapping_fun)

       cm_dist
    },mapping_fun=mapping_fun)
     mcols(new_gr) <- do.call(cbind,groups_rb)
     colnames(mcols(new_gr)) <- paste0(group_by,"_",mapping_fun)

  }
  new_gr
}

#' calGeneticDist
#'
#' Calculate genetic distances of marker intervals or binned-chromosome
#' Given whether crossover happens in each marker interval, calculate the
#' recombination fraction in samples and then derive the Haldane or Kosambi
#' genetic distances via mapping functions
#'
#' @param co_count
#' GRange or RangedSummarizedExperiment object, returned by \code{countCO}
#' @param bin_size
#' The binning size for grouping marker intervals into bins. If not supplied,the
#' orginial marker intervals are returned with converted genetic distancens
#' based on recombination rate
#' @param mapping_fun
#' The mapping function to use, can be one of "k" or "h" (kosambi or haldane)
#' @param ref_genome
#' The reference genome name. It is used to fetch the chromosome size
#' information from UCSC database.
#' @param chrom_info
#' A user supplied data.frame containing two columns with column names
#' chrom and size, describing the chromosome names and lengths if not using
#' ref_genome from UCSC. If supplied, the `ref_genome` is ignored.
#'
#' @param group_by, character vector contains the unique prefix of sample names
#' that are used for defining different sample groups. Or the column name in
#' colData(co_count) that specify the group factor. If missing all samples are
#' assumed to be from one group
#'
#' @importFrom rlang .data
#' @importFrom GenomeInfoDb getChromInfoFromUCSC genome genome<-
#' @importFrom GenomicRanges GRanges mcolAsRleList sort width
#' @importFrom GenomicRanges tileGenome binnedAverage mcols coverage
#' @importFrom GenomeInfoDb sortSeqlevels seqlevels seqinfo
#' @importFrom S4Vectors Rle
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment colData rowRanges
#' @return GRanges object
#' GRanges for marker intervals or binned intervals with Haldane or Kosambi
#' centiMorgans
#' @examples
#' data(coCount)
#' dist_se <- calGeneticDist(coCount)
#' # dist_se <- calGeneticDist(coCount,group_by="sampleGroup")
#'
#' @export
#'

setGeneric("calGeneticDist",
           function(co_count,
                    bin_size=NULL,
                    mapping_fun="k",
                    ref_genome="mm10",
                    group_by = NULL,
                    chrom_info = NULL)
             standardGeneric("calGeneticDist"))

#'@noRd
calGenetic_dist <- function(co_count,
                            bin_size=NULL,
                            mapping_fun="k",
                            ref_genome="mm10",
                            group_by = NULL,
                            chrom_info = NULL){
  stopifnot(is.null(bin_size) | is.numeric(bin_size))
  .check_mapping_fun(mapping_fun)
  new_gr <- cal_marker_dist(co_count = co_count,
                          mapping_fun = mapping_fun,
                          group_by = group_by)
  if(is.null(bin_size)){
    return(new_gr)
  } else {
    binned_dna_mm10_gr <- cal_bin_dist(new_gr=new_gr,bin_size=bin_size,
                                       ref_genome=ref_genome,
                                       chrom_info = chrom_info)
    return(binned_dna_mm10_gr)
  }

}

#'@noRd
cal_bin_dist <- function(new_gr,bin_size,
                         ref_genome="mm10",chrom_info = NULL){
  ## bin_size supplied then.
  ## fetch the chromoInfo from GenomeInfoDb.
  ## This is only for getting the basepair lengths of the genome

  if(is.null(chrom_info)){
      out <- tryCatch({
      chrom_info <- getChromInfoFromUCSC(ref_genome)
      chrom_info <- chrom_info[grep("_",chrom_info$chrom,invert = TRUE),]
  },
  error=function(cond) {
    message("The required genome is not available from UCSC.\n
            You can supply a chrom_info in data.frame that have\n
            the chrom names and lengths columns with 'chrom','size'\n
            as column names")
    stop()
  })
}
  stopifnot(c("chrom","size") %in% colnames(chrom_info))
  ## Check what seqnames is in new_gr and make it consistent
  if(!grepl("chr",as.character(seqnames(new_gr)[1]))){
    chrom_info$chrom <- gsub("chr","",chrom_info$chrom)
  }
  chrom_info <- chrom_info[chrom_info$chrom %in%
                             seqlevels(new_gr),]
  ## create Granges object for chromosomes
  seq_length <- chrom_info$size
  names(seq_length) <- chrom_info$chrom

  dna_mm10_gr <- GRanges(
    seqnames = Rle(names(seq_length)),
    ranges = IRanges(1, end = seq_length, names = names(seq_length)),
    seqlengths = seq_length)
  genome(dna_mm10_gr) <- ref_genome
  ## per bp distances
  mcols(new_gr) <- apply(mcols(new_gr),2,
                                        function(x) {
                                          x/width(new_gr)})

  tilewidth <- bin_size
  tiles <- tileGenome(seqinfo(dna_mm10_gr),
                                     tilewidth = tilewidth)
  binned_dna_mm10_gr <- unlist(tiles)
  # binned_dna_mm10_gr
  new_gr <- sort(sortSeqlevels(new_gr))

  bin_dist <-  bplapply(colnames(mcols(new_gr)), function(group_col){

    dist_rle <- coverage(new_gr,weight = mcols(new_gr)[,group_col])
    dist_bined <- binnedAverage(binned_dna_mm10_gr,dist_rle,
                                "dist_bin_ave")

    return(dist_bined$dist_bin_ave*width(dist_bined))

  })

  mcols(binned_dna_mm10_gr) <- do.call(cbind,bin_dist)
  colnames(mcols(binned_dna_mm10_gr)) <- colnames(mcols(new_gr))
  binned_dna_mm10_gr
}

#'@rdname calGeneticDist
setMethod("calGeneticDist",signature = c(co_count= 'GRanges',
                                         bin_size='missing',
                                         group_by='missing'),

          function(co_count,
                   bin_size=NULL,
                   mapping_fun="k",
                   ref_genome,
                   group_by = NULL,
                   chrom_info){
            .check_mapping_fun(mapping_fun)

            new_gr <- cal_marker_dist(co_count = co_count,
                                      mapping_fun = mapping_fun,
                                      group_by = NULL)
            new_gr
})
#'@rdname calGeneticDist
setMethod("calGeneticDist",signature = c(co_count = 'GRanges',
                                         bin_size='numeric',
                                         group_by='missing'),

          function(co_count,
                   bin_size=NULL,
                   mapping_fun="k",
                   ref_genome,
                   group_by = NULL,
                   chrom_info){
            .check_mapping_fun(mapping_fun)

            new_gr <- calGenetic_dist(co_count = co_count,
                                      mapping_fun = mapping_fun,
                                      bin_size = bin_size,
                                      ref_genome = ref_genome,
                                      group_by = NULL,
                                      chrom_info = chrom_info)
            new_gr
          })

#'@rdname calGeneticDist
setMethod("calGeneticDist",signature = c(co_count = 'GRanges',
                                         bin_size='missing',
                                         group_by='character'),

          function(co_count,
                   bin_size=NULL,
                   mapping_fun="k",
                   ref_genome,
                   group_by = NULL,
                   chrom_info){
            .check_mapping_fun(mapping_fun)

            new_gr <- cal_marker_dist(co_count = co_count,
                                      mapping_fun = mapping_fun,
                                      group_by = group_by)
            new_gr
})

#'@rdname calGeneticDist
setMethod("calGeneticDist",signature = c(co_count = 'GRanges',
                                         bin_size='numeric',
                                         group_by='character'),

          function(co_count,
                   bin_size,
                   mapping_fun="k",
                   ref_genome,
                   group_by,
                   chrom_info ){
            .check_mapping_fun(mapping_fun)

            new_gr <- calGenetic_dist(co_count = co_count,
                                      mapping_fun = mapping_fun,
                                      bin_size = bin_size,
                                      ref_genome = ref_genome,
                                      group_by = group_by,
                                      chrom_info = chrom_info)
            new_gr
          })

#' @keywords internal
#' @noRd
.setGenDistToRowRanges <- function(co_count,mapping_fun){
  cm_dist <- .rb_to_dist(rowRanges(co_count)$raw_rate, mapping_fun=mapping_fun)

  if(mapping_fun == "k")
    rowRanges(co_count)$kosambi <- cm_dist
  else
    rowRanges(co_count)$haldane <- cm_dist

  co_count
}

#'@rdname calGeneticDist
#'@importFrom SummarizedExperiment rowRanges rowRanges<-
#'
setMethod("calGeneticDist",
          signature = c(co_count = 'RangedSummarizedExperiment',
                        bin_size='missing',
                        group_by='missing'),

          function(co_count,
                   bin_size=NULL,
                   mapping_fun="k",
                   ref_genome="mm10",
                   group_by = NULL,
                   chrom_info){
            .check_mapping_fun(mapping_fun)
            co_rate <- rowMeans(as.matrix(assay(co_count)))
            rowRanges(co_count)$raw_rate <- co_rate

            co_count <- .setGenDistToRowRanges(co_count,
                                               mapping_fun = mapping_fun)
            co_count
          })

#'@rdname calGeneticDist
setMethod("calGeneticDist",
          signature = c(co_count = 'RangedSummarizedExperiment',
                        bin_size='missing',
                        group_by='character'),

          function(co_count,
                   bin_size=NULL,
                   mapping_fun="k",
                   ref_genome="mm10",
                   group_by,
                   chrom_info){
            .check_mapping_fun(mapping_fun)
            stopifnot(length(group_by)==1)
            ##group_by should refer to a column in colData(co_count)
            stopifnot(group_by %in% colnames(colData(co_count)))
            fcts <- colData(co_count)[,group_by]

            co_rate <- vapply(unique(as.character(fcts)),
                              function(fct){
                              rowMeans(as.matrix(assay(co_count)[,fcts==fct]))},
                              FUN.VALUE = numeric(nrow(assay(co_count))))

            rowRanges(co_count)$raw_rate <- co_rate


            co_count <- .setGenDistToRowRanges(co_count,
                                               mapping_fun = mapping_fun)
            co_count
          })


#'@rdname calGeneticDist
setMethod("calGeneticDist",
          signature = c(co_count = 'RangedSummarizedExperiment',
                        bin_size='numeric',
                        group_by='character'),

          function(co_count,
                   bin_size,
                   mapping_fun="k",
                   ref_genome="mm10",
                   group_by,
                   chrom_info){

            .check_mapping_fun(mapping_fun)
            stopifnot(length(group_by)==1)
            ##group_by should refer to a column in colData(co_count)
            stopifnot(group_by %in% colnames(colData(co_count)))
            fcts <- colData(co_count)[,group_by]

            #####
            # divide the cos into bins
            ####
            co_rate <- vapply(unique(as.character(fcts)),
                              function(fct){
                              rowMeans(as.matrix(assay(co_count)[,fcts==fct]))},
                              FUN.VALUE = numeric(nrow(assay(co_count))))

            rowRanges(co_count)$raw_rate <- co_rate
            ## divide into bins
            new_gr <- granges(co_count)
            mcols(new_gr) <- .rb_to_dist(co_rate, mapping_fun = mapping_fun)
            dist_gr <- cal_bin_dist(new_gr,bin_size = bin_size,
                                    ref_genome = ref_genome,
                                    chrom_info = chrom_info)
            dist_gr

          })



#'@rdname calGeneticDist
setMethod("calGeneticDist",
          signature = c(co_count = 'RangedSummarizedExperiment',
                        bin_size='numeric',
                        group_by='missing'),

          function(co_count,
                   bin_size,
                   mapping_fun="k",
                   ref_genome="mm10",
                   group_by =NULL,
                   chrom_info){

            .check_mapping_fun(mapping_fun)

            #####
            # divide the cos into bins
            ####
            co_rate <- rowMeans(as.matrix(assay(co_count)))

            rowRanges(co_count)$raw_rate <- co_rate
            ## divide into bins
            new_gr <- granges(co_count)
            mcols(new_gr) <- .rb_to_dist(co_rate, mapping_fun = mapping_fun)
            dist_gr <- cal_bin_dist(new_gr,bin_size = bin_size,
                                    ref_genome = ref_genome,
                                    chrom_info = chrom_info)
            dist_gr

        })

#' plotGTFreq
#'
#' Function to plot the genotypes for all samples faceted by genotype

#' @importFrom plotly plot_ly subplot
#' @importFrom reshape2 melt
#' @inheritParams countGT
#' @author Ruqian Lyu
#' @export
#' @return A ggplot object
#' @examples
#'
#' data(snp_geno)
#' or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
#' rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
#' or_geno[1,] <- rep("Fail",dim(or_geno)[2])
#' cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
#'                     alt = snp_geno$FVB.NJ..i.)
#' ft_gt <- filterGT(cr_geno)
#' plotGTFreq(ft_gt)

plotGTFreq <- function(geno){

  pltdf <- data.frame(geno) %>% pivot_longer(colnames(geno),
                                                    names_to = "sample",
                                                    values_to="geno")


  stplt1 <- ggplot(data = pltdf)+
    geom_bar(mapping = aes(x = sample, fill = geno),position = "fill")+
    theme_classic(base_size = 11)+
    ylab("Genotype Frequecies for each sample")+labs(color ="Genotype")+
    theme(axis.text.x = element_text(angle =-90))

  return(stplt1)

}

---
title: "single-sperm-co-analysis"
output: BiocStyle::html_document
bibliography: ref.bib
vignette: >
  %\VignetteIndexEntry{single-sperm-co-analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
suppressPackageStartupMessages({
  library(comapr)
  library(SummarizedExperiment)
  })
```

# Introduction

In the previous vignette, we demonstrated how to calculate genetic distances
using genotyped markers from a group of samples.

[Genetic distance calculate from genotype shifts of markers](getStarted.html)

In this document, we will focus on building individualized genetic maps from
output files of `sscocaller` which is available at 
[here](https://gitlab.svi.edu.au/biocellgen-public/sscocaller).

# Locate file path

The `comapr` package includes a list of toy example output files from the `sscocaller`
command line tool. The follow code will get the file path that we will use later.

```{r}
demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
```

We can see that we have two samples (individual donors) and each of them has 
haplotype states inferred for chr1 to chr5.

```{r}
list.files(demo_path)
```

# File information

- *.mtx
  - sparse matrix with columns corresponding to the list of sperm cell barcodes 
  and rows corresponding to the list of SNP positions in VCF file
  - {sample}_chr1_altCount.mtx, a sparse mtx with entries representing alternative allele counts
  - {sample}_chr1_totalCount.mtx, a sparse mtx with entries representing total allele counts
  - {sample}_chr1_vi.mtx, a sparse mtx with entries representing inferred viterbi state (haplotype state)


- {sample}_chr1_snpAnnot.txt, the SNP positions and allele
- {sample}_chr1_SegInfo.txt, statistics of viterbi state segments in text file format.
   It contains consecutive viterbi states for each chromosome with statistics including, 
   starting SNP position, ending SNP position, the number of SNPs supporting the segment, 
   the log likelihood ratio of the viterbi segment and the inferred hidden state.

# Diagnostic functions


`comapr` provides quality-check functions for examining SNP coverage per chr and 
per cell, chromosome segregation pattern checks, and summary statics for 
filtering low confidence crossovers.

## perCellChrQC

```{r}
pcQC <- perCellChrQC(sampleName="s1",chroms=c("chr1"),
                     path=paste0(demo_path,"/"),
                     barcodeFile=NULL)
```

# Input parsing

Input-parsing functions are implemented in `comapr` to construct 
`RangedSummarizedExpriment` object that parses files generated 
from `sscocaller` and filter out low-confidence COs at the same time. For the
demo dataset, these filters do not have any effects:

```
minSNP = 0, 
minlogllRatio = 50,
bpDist = 100,
maxRawCO=10,
minCellSNP = 1
```

# Construct `RangedSummarizedExpriment` object 

We first construct `RangedSummarizedExpriment` object from parsing output files
from `sscocaller` and filter out low-confidence crossovers.

```{r}
s1_rse_state <- readHapState("s1",chroms=c("chr1","chr2"),
                             path=demo_path,barcodeFile=NULL,
                             minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,
                             maxRawCO=10,
                             minCellSNP = 1)

s2_rse_state <- readHapState("s2",chroms=c("chr1","chr2"),
                             path=demo_path,
                             barcodeFile=NULL,
                             minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,
                             maxRawCO=10,
                             minCellSNP = 1)
```


```{r}
s1_rse_state
```

The Viterbi states for SNP markers are stored in the "assay" slot:

```{r}
assay(s1_rse_state)
```

The `rowRanges` contains the SNP's positions:

```{r}
rowRanges(s1_rse_state)
```

## Formate sample group factor

We have read in the Viterbi states for cells from two samples: s1 and s2. We now
combine them into one data object for downstream analysis.

## Add sample group factor

```{r}
colData(s1_rse_state)

colData(s1_rse_state)$sampleGroup <- "s1"

colData(s2_rse_state)$sampleGroup <- "s2"

```

## Combine two groups

We now call `combineHapState` function to combine sample s1 and sample s2
into one `RangedSummarizedExperiment` object.


```{r}
twoSample <- combineHapState(s1_rse_state,
                             s2_rse_state)
```

Now the `assay` data slot contains the Viterbi states across SNP positions for
the combined samples.

```{r}
twoSample <- combineHapState(s1_rse_state,s2_rse_state)
```


Now the `twoSample` object contains the cells from both samples with `assay` slot
contains the Viterbi states and `rowRanges` contains position annotaitons for
the list SNP markers.

```{r}

assay(twoSample)
```

# Count crossovers 

The `countCOs` function can then find out the crossover intervals according to 
the Viterbi states for each cell and the number of crossovers per cell is then
calculated.

# Count crossovers for SNP intervals

`countCOs` function will find the crossover intervals for each samples and 
attribute the observed crossovers from each sample to the corresponding intervals.

```{r}
cocounts <- countCOs(twoSample)
```

The `rowRanges` from the resulting data object now denotes the crossover interval
and the `assay` slot now contains the number of crossovers in each cell.


Now `rowRanges` contains the intervals

```{r}
rowRanges(cocounts)
```

The colData slot still contains the annotations of each cell.

```{r}
colData(cocounts)
```

# Calculate genetic distances

The genetic distances can be calculated by using mapping functions such as the
Kosambi or Haldane \cite{} and `assay` slot contains the number of crossovers 
found in each sample across these intervals.

```{r}
assay(cocounts)
```


# Calculate genetic distances

`calGeneticDist` function will convert the raw crossover frequencies to genetic
distances via selected mapping function (ie. kosambi or haldane).

```{r}
dist_gr <- calGeneticDist(co_count = cocounts, mapping_fun = "k")
dist_gr
```

The genetic distances for each interval are stored in `rowData`.

```{r}
rowData(dist_gr)
```

The above genetic distances have been calculated using all samples. We can also
specify the group factor so that we can calculate genetic distances for different
sample groups:

```{r}
## sampleGroup is a column in the colData slot
dist_gr <- calGeneticDist(co_count = cocounts,
                          group_by  = "sampleGroup",
                          mapping_fun = "k")

```

Now the group/Sample specific distances are stored in `rowData`

```{r}
rowData(dist_gr)$kosambi
```

# Plot whole genome genetic distances

We construct a `GRange` object from the `dist_gr` first.

```{r}
p_gr <- granges(dist_gr)
mcols(p_gr) <- rowData(dist_gr)$kosambi


```

We can plot whole-genome genetic distances

```{r}
plotWholeGenome(p_gr)

```

We can also do per chromosome plot

```{r}
plotGeneticDist(p_gr,chr = "chr1",cumulative = TRUE)

```




# Group differences

`bootstrapDist` function generates the sampling distribution of the difference
in total genetic distances for the two groups under comparisons.

```{r}
set.seed(100)
bootsDiff <- bootstrapDist(co_gr = cocounts,B=10,
                           group_by = "sampleGroup")
```

```{r}
hist(bootsDiff)
```

From the `bootsDiff` data object, we can find a 95% confidence interval to test
whether the difference is statistically significant. 

```{r}
quantile(bootsDiff,c(0.025,0.975),na.rm =TRUE)
```


An alternative re-sampling method, `permuteDist`, can be applied to generate a
null distribution for the group difference by reshuffling the group labels across
the samples.

```{r}
set.seed(100)
perms <- permuteDist(cocounts,B=1000,group_by = "sampleGroup")
```

 A p-value can be calculated using the `statmod::permp` function [@Phipson2010-xi].

```{r}
statmod::permp(x = sum(perms$permutes>=perms$observed_diff,
                       na.rm = TRUE),
               nperm = sum(!is.na(perms$permutes)),
               n1 = perms$nSample[1],
               n2 = perms$nSample[2])

```

# Session info

```{r}
sessionInfo()
```

---
title: "Genetic distance calculation from genotype shifts of markers"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Get-Started-With-comapr}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
  
author: Ruqian Lyu
date: "`r format(Sys.time(), '%d %B, %Y')`"
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(comapr)
library(GenomicRanges)
library(BiocParallel)
```

# Installation

Install via BiocManager as follow:

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("comapr")
```

# Introduction

`comapr` lets you interrogate the genotyping results for a sequence of markers 
across the chromosome and detect meiotic crossovers from genotype shifts. In 
this document, we demonstrate how genetic distances are calculated from genotyping 
results for a group of samples using functions available from `comapr`.


# The demo data set of genotyping results

The package includes a small data object that contains 70 markers and their genotyping
results for 22 samples. The 22 samples are the BC1F1 progenies generated by 

- Generating F1 hybrid mice by crossing an inbred C57BL/6J mouse and an inbred FVB/NJ mouse 
- Crossing F1 hybrid mice with inbred FVB/NJ

Therefore, the genotype shifts detected in BC1F1 samples represent crossovers that
have happened during meiosis for the F1 parents.

```{r}
BiocParallel::register(SerialParam())
BiocParallel::bpparam()
```

```{r}
data(snp_geno_gr)
data(parents_geno)
```

## Format the genotype

In order to detect crossovers from the 22 samples' genotype results (BC1F1 
samples), we need to format the result into `Homo_ref`, `Homo_alt` and `Het`
encodings. This can be simply done through comparing with the parents' genotypes.

Here, the genotype noted as "Fail" will be converted to NA. Please also note that
we supplied "Homo_ref" as one of the fail options because "Homo_ref" is not in
the possible genotypes of markers in BC1F1 samples.


```{r}
corrected_geno <- correctGT(gt_matrix = mcols(snp_geno_gr),
                            ref = parents_geno$ref,
                            alt = parents_geno$alt,
                            fail = "Fail",
                            wrong_label = "Homo_ref")

mcols(snp_geno_gr) <- corrected_geno
```

The `corrected_geno` matrix 

```{r}
head(mcols(snp_geno_gr)[,1:5])

```

Note that there are missing values in this resulting matrix that can be resulted
from:

- No genotype data from the genotyping result
- The genotype is wrong and it is converted to `NA`

## Find outlier samples/markers

In this step, we try to identify markers that have `NA` genotype across many 
samples or samples that have a lot markers failed for removal. We use the 
`countGT` function for find bad markers/samples.

```{r}
genotype_counts <- countGT(mcols(snp_geno_gr))

genotype_counts$plot
```

The number of markes and samples are saved in a list returned by `countGT`

```{r}
genotype_counts$n_markers
genotype_counts$n_samples
```

We now filter out markers/samples by using function `filterGT`. `min_markers` 
specifies at least how many markers a sample needs to be kept. Likewise for 
`min_samples`.

A printed message contains information about how much markers or samples have 
been filtered.

```{r}
corrected_geno <- filterGT(snp_geno_gr,
                           min_markers = 30,
                           min_samples = 2)
```

## Find sample duplicates

Sample duplicates are identified by finding samples that share exactly same genotypes
across all available markers. `findDupSamples` can be applied and a threshold 
value is provided and used as a cut-off on the percentage of same genotype markers
the duplicated samples should share.

```{r}
dups <- findDupSamples(mcols(corrected_geno),
                       threshold = 0.99)
dups
```

Now we remove the duplicated samples.

```{r}
mcols(corrected_geno) <- mcols(corrected_geno)[,colnames(mcols(corrected_geno))!="X98"]
#corrected_geno
```


## Count crossovers

Crossovers are detected and counted through examining the patterns of genotypes 
along the chromosome. When there is a shift from one genotype block to another,
a crossover is observed. This is done through calling `countCOs` function which
returns a `GRange` object with crossover counts for the list of marker intervals.

The crossover count values in the columns can be non-integer when one observed
crossover can not be determined to be completely distributed to the marker interval
in the corresponding row. The observed crossover is then distributed to the adjacent
intervals proportionally to their interval base pair sizes.

```{r}
marker_gr_cos <- countCOs(corrected_geno)

marker_gr_cos[1:5,1:5]
```

## Calculate genetic distance 

The genetic distances of marker intervals are calcuated based on the crossover 
rates via applying mapping function, `Kosambi` or `Haldane` by calling the
`calGeneticDist` function. The returned genetic distances are in unit of
centiMorgan.

```{r}
dist_gr <- calGeneticDist(marker_gr_cos,
                          mapping_fun = "k")

dist_gr[1:5,]
```

## Calculate genetic distance for equally binned intervals 

Alternatively, instead of returning the genetic distances in supplied marker 
intervals, we can specify a `bin_size` which tells `calGeneticDist` to return 
calculated genetic distances for equally sized chromosome bins.

```{r}
dist_bin_gr <- calGeneticDist(marker_gr_cos,bin_size = 1e6)

dist_bin_gr[1:5,]
```


## Total genetic distances

With genetic distances calculated, we can do a sum of all genetic distances across
all marker intervals. We can see that we got the same total genetic distances
for marker based intervals and the equally binned intervals.

```{r}
sum(dist_bin_gr$kosambi_cm)
sum(dist_gr$kosambi_cm)

```

## Plotting genetic distance for each bin

`comapr` also includes functions for visulising genetic distances of marker 
intervals or binned intervals.


```{r}
plotGeneticDist(dist_bin_gr,chr = "1")
```


## Plot cumulative distances

We can also plot the cumulative genetic distances of certain chromosomes

```{r}
plotGeneticDist(dist_bin_gr,chr=c("1"),cumulative = TRUE)

```

Multiple chromosomes

```{r,fig.height=10,fig.width=8}
plotGeneticDist(dist_bin_gr,cumulative = TRUE)
```

## Whole Genome Genetic distances Plot

`comapr` implements a whole genome plot function too, that takes all chromosomes
available in the result and plot a cumulative genetic distances by cumulatively 
summing all intervals across all chromosomes.


```{r}
plotWholeGenome(dist_bin_gr)
```


# Sessioninfo

```{r sessioninfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-mean-dp-track.R
\name{getMeanDPTrack}
\alias{getMeanDPTrack}
\title{getMeanDPTrack}
\usage{
getMeanDPTrack(
  chrom = "chr1",
  path_loc,
  nwindow = 80,
  sampleName,
  barcodeFile,
  plot_type = "hist",
  selectedBarcodes = NULL,
  snp_track = NULL,
  log = TRUE
)
}
\arguments{
\item{chrom}{the chromosome}

\item{path_loc}{the path prefix to the output files from sscocaller including
"*_totalCount.mtx" and "_altCount.mtx"}

\item{nwindow}{the number of windows for binning the chromosome}

\item{sampleName}{the sample name, which is the prefix of sscocaller's output
files}

\item{barcodeFile}{the barcode file containing the list of cell barcodes used
as the input file for sscocaller}

\item{plot_type, }{the DataTrack plot type, default to be `hist`}

\item{selectedBarcodes, }{the selected cell barcodes which should be the
barcodes that have been called crossovers for. If not supplied then all cells
are counted.}

\item{snp_track}{the SNP position track which is used for obtaining the SNP
chromosome locations. It could be omitted and the SNP positions will be acquired
from the "*_snpAnnot.txt" file.}

\item{log, }{whether the histogram of SNP density should be plotted on log
scale (log10)}
}
\value{
DataTrack object plotting the mean DP histogram for windowed
chromosomes
}
\description{
Generate the mean DP (Depth) DataTrack (from Gviz) for cells
}
\examples{
demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
meanDP_track <- getMeanDPTrack(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1",
                               barcodeFile = paste0(demo_path,
                                                    "s1_barcodes.txt"))

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{snp_geno}
\alias{snp_geno}
\title{Markers by genotype results for a group of samples}
\format{
A data frame with columns:
\describe{
 \item{C57BL.6J}{genotype of reference mouse train across markers}
 \item{FVB.NJ..i.}{genotype of alternative mouse train across markers}
 \item{POS}{SNP marker base-pair location }
 \item{CHR}{SNP marker chromosome location}
 \item{X100}{a mouse sample }
 \item{X101}{a mouse sample }
 \item{X102}{a mouse sample }
 \item{X103}{a mouse sample }
 \item{X104}{a mouse sample }
 \item{X105}{a mouse sample }
 \item{X106}{a mouse sample }
 \item{X107}{a mouse sample }
 \item{X108}{a mouse sample }
 \item{X109}{a mouse sample }
 \item{X110}{a mouse sample }
 \item{X111}{a mouse sample }
 \item{X112}{a mouse sample }
 \item{X113}{a mouse sample }
 \item{X92}{a mouse sample }
 \item{X93}{a mouse sample }
 \item{X94}{a mouse sample }
 \item{X95}{a mouse sample }
 \item{X96}{a mouse sample }
 \item{X97}{a mouse sample }
 \item{X98}{a mouse sample }
 \item{X99}{a mouse sample }
 \item{rsID}{the SNP ID}
}
}
\source{
Statistics Canada. Table 001-0008 - Production and farm value of
 maple products, annual. \url{http://www5.statcan.gc.ca/cansim/}
}
\usage{
data(snp_geno)
}
\description{
Markers by genotype results for a group of samples
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-af-tracks.R
\name{getAFTracks}
\alias{getAFTracks}
\title{getAFTracks}
\usage{
getAFTracks(
  chrom = "chr1",
  path_loc = "./output/firstBatch/WC_522/",
  sampleName = "WC_522",
  nwindow = 80,
  barcodeFile,
  co_count,
  snp_track = NULL
)
}
\arguments{
\item{chrom}{the chromosome}

\item{path_loc}{the path prefix to the output files from sscocaller including
"*_totalCount.mtx" and "_altCount.mtx"}

\item{sampleName}{the sample name, which is the prefix of sscocaller's output
files}

\item{nwindow}{the number of windows for binning the chromosome}

\item{barcodeFile}{the barcode file containing the list of cell barcodes used
as the input file for sscocaller}

\item{co_count}{`GRange` or `RangedSummarizedExperiment` object,
returned by \code{countCO} that contains the crossover intervals and the number
of crossovers in each cell.}

\item{snp_track}{the SNP position track which is used for obtaining the SNP
chromosome locations. It could be omitted and the SNP positions will be acquired
from the "*_snpAnnot.txt" file.}
}
\value{
a list object, in which each element is a list of two items with the
cell's alternative allele frequency DataTrack and the called crossover ranges.
}
\description{
Generate the raw alternative allele frequencies tracks for all cells in the
columns of provided `co_count`
}
\examples{
demo_path <- system.file("extdata",package = "comapr")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_counts <- countCOs(s1_rse_state)

af_co_tracks <- getAFTracks(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1",
                               barcodeFile = file.path(demo_path,
                                                    "s1_barcodes.txt"),
                               co_count = s1_counts)

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{permuteDist}
\alias{permuteDist}
\title{permuteDist}
\usage{
permuteDist(co_gr, B = 100, mapping_fun = "k", group_by)
}
\arguments{
\item{co_gr}{GRanges or RangedSummarizedExperiment object that contains the
crossover counts for each marker interval across all samples.
Returned by \code{countCOs}}

\item{B}{integer the number of sampling times}

\item{mapping_fun}{character default to "k" (kosambi mapping function). It
can be one of the mapping functions: "k","h"}

\item{group_by}{the prefix for each group that we need to generate
distributions for(only when co_gr is a GRanges object). Or the column name
for `colData(co_gr)` that contains the
group factor (only when co_gr is a RangedSummarizedExperiment object)}
}
\value{
A list of three elements. `permutes` of length B with numeric
differences of permuted group differences,`observed_diff` the observed
genetic distances of two groups, `nSample`, the number of samples in the
first and second group.
}
\description{
Permutation test of two sample groups
}
\details{
It shuffles the group labels for the samples and calculate a difference
between two groups after shuffling.
}
\examples{
data(coCount)
perms <- permuteDist(coCount, group_by = "sampleGroup",B=10)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count-gt.R
\name{filterGT}
\alias{filterGT}
\alias{filterGT,matrix,numeric,numeric-method}
\alias{filterGT,GRanges,numeric,numeric-method}
\title{filterGT}
\usage{
filterGT(geno, min_markers = 5, min_samples = 3)

\S4method{filterGT}{matrix,numeric,numeric}(geno, min_markers = 5, min_samples = 3)

\S4method{filterGT}{GRanges,numeric,numeric}(geno, min_markers = 5, min_samples = 3)
}
\arguments{
\item{geno}{the genotype data.frame of markers by samples from output of
function \code{correctGT}}

\item{min_markers}{the minimum number of markers for a sample to be kept}

\item{min_samples}{the minimum number of samples for a marker to be kept}
}
\value{
The filtered genotype matrix
}
\description{
Filter markers or samples that have too many missing values
}
\details{
This function takes the \code{geno} data.frame and filter the data.frame by
the provided cut-offs.
}
\examples{
data(snp_geno_gr)
corrected_geno <- filterGT(snp_geno_gr, min_markers = 30,min_samples = 2)

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count-co.R
\name{countCOs}
\alias{countCOs}
\alias{countCOs,GRanges-method}
\alias{countCOs,RangedSummarizedExperiment-method}
\title{countCOs}
\usage{
countCOs(geno)

\S4method{countCOs}{GRanges}(geno)

\S4method{countCOs}{RangedSummarizedExperiment}(geno)
}
\arguments{
\item{geno}{GRanges object or RangedSummarizedExperiment object with genotype
matrix that has SNP positions in the rows and cells/samples in the columns}
}
\value{
GRanges object or RangedSummarizedExperiment with markers-intervals as rows
and samples in columns, values as the number of COs estimated for each marker
interval
}
\description{
Count number of COs within each marker interval
COs identified in the interval overlapping missing markers are distributed
according to marker interval base-pair sizes. Genotypes encoded with "0" are
treated as missing value.
}
\examples{
data(twoSamples)
cocount <- countCOs(twoSamples)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reformat-geno-mt.R
\name{correctGT}
\alias{correctGT}
\title{correctGT}
\usage{
correctGT(gt_matrix, ref, alt, failed = "Fail", wrong_label = "Homo_ref")
}
\arguments{
\item{gt_matrix}{the input genotype matrix of markers by samples with rownames as marker IDs
and column names as sample IDs}

\item{ref}{a vector of genotypes of the inbred reference strain}

\item{alt}{a vector of genotypes of the inbred alternative strain}

\item{failed}{what was used for encoding failed genotype calling such as "Fail" in example
data \code{snp_geno}}

\item{wrong_label}{what would be considered a wrong genotype label for example Homo_ref which
should not be in the possible genotypes of BC1F1 samples}
}
\value{
a genotype data.frame of sample genotypes with dimension as the input
`gt_matrix` with genotypes converted to labels and failed calls are changed
to NA.
}
\description{
function for formatting and correction genotypes of markers
}
\details{
This function changes genotype in alleles to genotype labels, change Homo_ref
to Hets/Fail, infer Failed genotype, and change "Failed" to NA for
counting crossover later


This function changes genotype in alleles to labels by calling internal
functions \code{lable_gt}, and changes the wrong genotype Homo_ref to Fail by
calling \code{.change_missing}.
}
\examples{
data(snp_geno_gr)
data(parents_geno)
snp_gt_crt <- correctGT(gt_matrix = GenomicRanges::mcols(snp_geno_gr),
                      ref = parents_geno$ref,
                      alt = parents_geno$alt,
                      fail = "Fail",
                      wrong_label = "Homo_ref")
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{twoSamples}
\alias{twoSamples}
\title{RangedSummarizedExperiment object containing the Viterbi states SNP markers
for samples from two groups. `colData(twoSamples)` contains the sample group
factor.}
\format{
An object of class \code{RangedSummarizedExperiment} with 6 rows and 10 columns.
}
\usage{
data(twoSamples)
}
\description{
RangedSummarizedExperiment object containing the Viterbi states SNP markers
for samples from two groups. `colData(twoSamples)` contains the sample group
factor.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-mean-dp-track.R
\name{getCellDPTrack}
\alias{getCellDPTrack}
\title{getCellDPTrack
Generates the DataTrack for plotting DP of a selected cell}
\usage{
getCellDPTrack(
  chrom = "chr1",
  path_loc = "./output/firstBatch/WC_522/",
  sampleName = "WC_522",
  nwindow = 80,
  barcodeFile,
  cellBarcode,
  snp_track = NULL,
  chunk = 1000L,
  log = TRUE,
  plot_type = "hist"
)
}
\arguments{
\item{chrom, }{the chromosome}

\item{path_loc, }{the path prefix to the output files from sscocaller
including "*_totalCount.mtx"}

\item{sampleName}{the sample name, which is the prefix of sscocaller's output
files}

\item{nwindow, }{the number of windows for binning the chromosome}

\item{barcodeFile, }{the barcode file containing the list of cell barcodes
used as the input file for sscocaller}

\item{cellBarcode, }{the selected cell barcode}

\item{snp_track, }{the SNP position track which is used for obtaining the SNP
chromosome locations. It could be omitted and the SNP positions will be
acquired from the "*_snpAnnot.txt" file.}

\item{chunk, }{A integer scalar indicating the chunk size to use, i.e., number
of rows to read at any one time.}

\item{log}{whether the histogram of SNP density should be plotted on log
scale (log10)}

\item{plot_type}{the DataTrack plot type, default to be `hist`}
}
\value{
The DataTrack object defined in \code{\link[Gviz]{DataTrack}}
}
\description{
It plots the total allele counts for the selected cell.
}
\examples{
demo_path <- system.file("extdata",package = "comapr")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_counts <- countCOs(s1_rse_state)
dp_co_tracks <- getCellDPTrack(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1",
                               barcodeFile = file.path(demo_path,
                                                    "s1_barcodes.txt"),
                               cellBarcode = "BC1")

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{bootstrapDist}
\alias{bootstrapDist}
\title{bootstrapDist}
\usage{
bootstrapDist(co_gr, B = 1000, mapping_fun = "k", group_by)
}
\arguments{
\item{co_gr}{GRanges or RangedSummarizedExperiment object that contains the
crossover counts for each marker interval across all samples.
Returned by \code{countCOs}}

\item{B}{integer the number of sampling times}

\item{mapping_fun}{character default to "k" (kosambi mapping function). It
can be one of the mapping functions: "k","h"}

\item{group_by, }{the prefix for each group that we need to generate
distributions for(only when co_gr is a GRanges object). Or the column name
for `colData(co_gr)` that contains the
group factor (only when co_gr is a RangedSummarizedExperiment object)}
}
\value{
lists of numeric genetic distances for multiple samples
}
\description{
Generating distribution of sample genetic distances
}
\details{
It takes the crossover counts for samples in multiple groups that is returned
by `countCO`. It then draws samples from a group with replacement and
calculate the distribution of relevant statistics.
}
\examples{
data(coCount)

bootsDiff <- bootstrapDist(coCount, group_by = "sampleGroup",B=10)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cal-genetic-dist.R
\name{calGeneticDist}
\alias{calGeneticDist}
\alias{calGeneticDist,GRanges,missing,ANY,ANY,missing-method}
\alias{calGeneticDist,GRanges,numeric,ANY,ANY,missing-method}
\alias{calGeneticDist,GRanges,missing,ANY,ANY,character-method}
\alias{calGeneticDist,GRanges,numeric,ANY,ANY,character-method}
\alias{calGeneticDist,RangedSummarizedExperiment,missing,ANY,ANY,missing-method}
\alias{calGeneticDist,RangedSummarizedExperiment,missing,ANY,ANY,character-method}
\alias{calGeneticDist,RangedSummarizedExperiment,numeric,ANY,ANY,character-method}
\alias{calGeneticDist,RangedSummarizedExperiment,numeric,ANY,ANY,missing-method}
\title{calGeneticDist}
\usage{
calGeneticDist(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{GRanges,missing,ANY,ANY,missing}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{GRanges,numeric,ANY,ANY,missing}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{GRanges,missing,ANY,ANY,character}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{GRanges,numeric,ANY,ANY,character}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{RangedSummarizedExperiment,missing,ANY,ANY,missing}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{RangedSummarizedExperiment,missing,ANY,ANY,character}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{RangedSummarizedExperiment,numeric,ANY,ANY,character}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)

\S4method{calGeneticDist}{RangedSummarizedExperiment,numeric,ANY,ANY,missing}(
  co_count,
  bin_size = NULL,
  mapping_fun = "k",
  ref_genome = "mm10",
  group_by = NULL,
  chrom_info = NULL
)
}
\arguments{
\item{co_count}{GRange or RangedSummarizedExperiment object, returned by \code{countCO}}

\item{bin_size}{The binning size for grouping marker intervals into bins. If not supplied,the
orginial marker intervals are returned with converted genetic distancens
based on recombination rate}

\item{mapping_fun}{The mapping function to use, can be one of "k" or "h" (kosambi or haldane)}

\item{ref_genome}{The reference genome name. It is used to fetch the chromosome size
information from UCSC database.}

\item{group_by, }{character vector contains the unique prefix of sample names
that are used for defining different sample groups. Or the column name in
colData(co_count) that specify the group factor. If missing all samples are
assumed to be from one group}

\item{chrom_info}{A user supplied data.frame containing two columns with column names
chrom and size, describing the chromosome names and lengths if not using
ref_genome from UCSC. If supplied, the `ref_genome` is ignored.}
}
\value{
GRanges object
GRanges for marker intervals or binned intervals with Haldane or Kosambi
centiMorgans
}
\description{
Calculate genetic distances of marker intervals or binned-chromosome
Given whether crossover happens in each marker interval, calculate the
recombination fraction in samples and then derive the Haldane or Kosambi
genetic distances via mapping functions
}
\examples{
data(coCount)
dist_se <- calGeneticDist(coCount)
# dist_se <- calGeneticDist(coCount,group_by="sampleGroup")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reformat-geno-mt.R
\name{.change_missing}
\alias{.change_missing}
\title{change SNPs with genotype 'Fail' to \code{NA}}
\usage{
.change_missing(s_gt, missing = "Fail")
}
\arguments{
\item{s_gt, }{a column of labelled genotypes}

\item{missing, }{the string used for encoding missing values default to
\code{Fail}}
}
\value{
a vector of genotypes with Fail substituted by `NA`
}
\description{
change SNPs with genotype 'Fail' to \code{NA}
}
\details{
calculation.
}
\author{
Ruqian Lyu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find-dup-samples.R
\name{findDupSamples}
\alias{findDupSamples}
\title{findDupSamples}
\usage{
findDupSamples(geno, threshold = 0.99, in_text = FALSE)
}
\arguments{
\item{geno}{the genotype data.frame of markers by samples from output of
function \code{correctGT}}

\item{threshold}{the frequency cut-off of number of matching genotypes out of
all geneotypes for determining whether the pair of samples
are duplicated, defaults to \code{0.99}. NAs are regarded as same genotypes for
two samples if they both have NA for a marker.}

\item{in_text}{whether text of frequencies should be displayed in the
heatmap cells}
}
\value{
The paris of duplicated samples.
}
\description{
Find the duplicated samples by look at the number of matching genotypes
in all pair-wise samples
}
\examples{
data(snp_geno)
or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
or_geno[,1] <- or_geno[,5]
cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                    alt = snp_geno$FVB.NJ..i.)
dups <- findDupSamples(cr_geno)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reformat-geno-mt.R
\name{fill_fail}
\alias{fill_fail}
\title{Infer the genotype of failed SNPs
If we have a \code{Fail} in the genotype data and the \code{Fail} in a block
of either Home_alt, or Het, we fill in the \code{Fail}s using values of the
ones adjacent to it, otherwise they remain as "Fail" to indicate missing
values.}
\usage{
fill_fail(s_gt, fail = "Fail", chr = NULL)
}
\arguments{
\item{s_gt, }{a column of labelled genotypes}

\item{fail, }{the string that is used for encoding failed genotype results,
default to \code{Fail}}

\item{chr, }{the factor vector indicating which chromosomes the markers are
on, default to \code{NULL} which means the input markers are all on the same
chromosome.}
}
\value{
a vector of genotypes with Failed genotype imputed or changed to `NA` if not
imputable
}
\description{
Infer the genotype of failed SNPs
If we have a \code{Fail} in the genotype data and the \code{Fail} in a block
of either Home_alt, or Het, we fill in the \code{Fail}s using values of the
ones adjacent to it, otherwise they remain as "Fail" to indicate missing
values.
}
\author{
Ruqian Lyu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count-gt.R
\name{countGT}
\alias{countGT}
\title{countGT}
\usage{
countGT(geno, plot = TRUE, interactive = FALSE)
}
\arguments{
\item{geno}{the genotype data.frame of markers by samples from output of
function \code{correctGT}}

\item{plot, }{it determines whether a plot will be generated, defaults to TRUE}

\item{interactive, }{it determines whether an interactive plot will be generated}
}
\value{
A list of two elements including \code{n_markers} and \code{n_samples}
}
\description{
count how many samples have genotypes calls across markers and count how
many markers that each individual has called genotypes for. This function
helps identify poor samples or poor markers for filtering. It can also generate
plots that help identify outlier samples/markers
}
\examples{
data(snp_geno_gr)
genotype_counts <- countGT(GenomicRanges::mcols(snp_geno_gr))
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-snp-den-track.R
\name{getSNPDensityTrack}
\alias{getSNPDensityTrack}
\title{getSNPDensityTrack}
\usage{
getSNPDensityTrack(
  chrom = "chr1",
  sampleName = "s1",
  path_loc = ".",
  nwindow = 80,
  plot_type = "hist",
  log = TRUE
)
}
\arguments{
\item{chrom}{the chromosome}

\item{sampleName}{the sample name, which is the prefix of sscocaller's output
files}

\item{path_loc}{the path prefix to the output files from sscocaller including
"*_totalCount.mtx" and "_altCount.mtx"}

\item{nwindow}{the number of windows for binning the chromosome}

\item{plot_type, }{the DataTrack plot type, default to be `hist`}

\item{log, }{whether the histogram of SNP density should be plotted on log
scale (log10)}
}
\value{
DataTrack object plotting the SNP density histogram
}
\description{
Generate the SNP density DataTrack (from `Gviz`) for selected chromosome
}
\examples{
demo_path <- system.file("extdata",package = "comapr")
snp_track <- getSNPDensityTrack(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1")
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diagnostic-qc-checks.R
\name{perSegChrQC}
\alias{perSegChrQC}
\title{perSegChrQC}
\usage{
perSegChrQC(
  sampleName,
  chroms = c("chr1", "chr7", "chr15"),
  path,
  barcodeFile = NULL,
  maxRawCO = 10
)
}
\arguments{
\item{sampleName, }{the name of the sample to parse which is used as prefix
for finding relevant files for the underlying sample}

\item{chroms, }{the vector of chromosomes}

\item{path, }{the path to the files, with name patterns *{chrom}_vi.mtx,
*{chrom}_viSegInfo.txt, end with slash}

\item{barcodeFile, }{defaults to NULL, it is assumed to be in the same
directory as the other files and with name sampleName_barcodes.txt}

\item{maxRawCO, }{if a cell has more than `maxRawCO` number of raw crossovers
called across a chromosome, the cell is filtered out#'}
}
\value{
Histogram plots for statistics summarized across all Viterbi state
segments
}
\description{
Plots the summary statistics of segments that are generated by `sgcocaller`
\url{https://gitlab.svi.edu.au/biocellgen-public/sgcocaller}
which have been detected by finding consequtive viter states along the list
of SNP markers.
}
\details{
It provides guidance in filtering out close double crossovers that are not
likely biological but due to technical reasons as well as crossovers that are
supported by fewer number of SNPs at the ends of the chromosomes.
}
\examples{
demo_path <- system.file("extdata",package = "comapr")
s1_rse_qc <- perSegChrQC(sampleName="s1",
                            chroms=c("chr1"),
                            path=demo_path, maxRawCO=10)

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-gt-freq.R
\name{plotGTFreq}
\alias{plotGTFreq}
\title{plotGTFreq}
\usage{
plotGTFreq(geno)
}
\arguments{
\item{geno}{the genotype data.frame of markers by samples from output of
function \code{correctGT}}
}
\value{
A ggplot object
}
\description{
Function to plot the genotypes for all samples faceted by genotype
}
\examples{

data(snp_geno)
or_geno <- snp_geno[,grep("X",colnames(snp_geno))]
rownames(or_geno) <- paste0(snp_geno$CHR,"_",snp_geno$POS)
or_geno[1,] <- rep("Fail",dim(or_geno)[2])
cr_geno <- correctGT(or_geno,ref = snp_geno$C57BL.6J,
                    alt = snp_geno$FVB.NJ..i.)
ft_gt <- filterGT(cr_geno)
plotGTFreq(ft_gt)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read-hap-state.R
\name{.filterCOsExtra}
\alias{.filterCOsExtra}
\title{Filter out doublet cells and uninformative SNPs}
\usage{
.filterCOsExtra(
  se,
  minSNP = 30,
  minlogllRatio = 200,
  minCellSNP = 200,
  bpDist = 100,
  maxRawCO = 10,
  biasTol = 0.45,
  nmad = 1.5
)
}
\arguments{
\item{se, }{the SummarizedExperiment object that contains the called haplotype
state matrix in the assay field and haplotype segment information in the metadata
field.}

\item{minSNP, }{the crossover(s) will be filtered out if introduced by a segment
that has fewer than `minSNP` SNPs to support.}

\item{minlogllRatio, }{the crossover(s) will be filtered out if introduced by a
segment that has lower than `minlogllRatio` to its reversed state.}

\item{minCellSNP, }{the minimum number of SNPs detected for a cell to be kept,
used with `nmads`}

\item{bpDist, }{the crossover(s) will be filtered out if introduced by a segment
that is shorter than `bpDist` basepairs.}

\item{maxRawCO, }{if a cell has more than `maxRawCO` number of raw crossovers
called across a chromosome, the cell is filtered out}

\item{biasTol, }{the SNP's haplotype ratio across all cells is assumed
to be 1:1. This argument can be used for removing SNPs that have a biased
haplotype. i.e. almost always inferred to be haplotype state 1. It specifies
a bias tolerance value, SNPs with haplotype ratios deviating from 0.5 smaller
than this value are kept. Only effective when number of cells are larger than
10}

\item{nmad, }{how many mean absolute deviations lower than the median number
of SNPs per cellfor a cell to be considered as low coverage cell and filtered
Only effective when number of cells are larger than 10. When effective, this or
`minCellSNP`, whichever is larger, is applied}
}
\value{
A `RangedSummarizedExperment` object that have different dims with input.
the colnames are the cell barcodes, rowRanges specify the location of SNPs that
contribute to crossovers.
}
\description{
This function filter out cells that have been called too many crossovers due
to diploid cell contamination or doublets. It also only keeps SNPs (rows) that
ever contribute to a crossover interval. This function should be run for
individual chromosomes and is called internaly by `readHapState`
}
\details{
The `logllRatio` value is returned by `sgcocaller` for each haplotype
segment formed by consecutive SNPs that are called to have a same state. It is
calculated by taking log of ratio (likelihood of SNPs with inferred states)
and (likelihood of SNPs with reversed states)
}
\author{
Ruqian Lyu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-distorted-markers.R
\name{getDistortedMarkers}
\alias{getDistortedMarkers}
\title{getDistortedMarkers}
\usage{
getDistortedMarkers(geno, p = c(0.5, 0.5), adj.method = "BH")
}
\arguments{
\item{geno}{the genotype data.frame of markers by samples from output of
function \code{correctGT}}

\item{p}{the expected geneotype ratio in a numeric vector, defaults to c(0.5,0.5)}

\item{adj.method}{Methods to adjust for multiple comparisons, defaults to "BH"}
}
\value{
data.frame with each row representing one SNP marker and columns
containing the chisq.test results
}
\description{
Marker segregation distortion detection using chisq-test
}
\details{
We expect the genotypes to appear with the frequencies of 1:1 homo_alt:hets.
We usechisq.test for finding markers that have genotypes among samples that
are significantly different from the 1:1 ratio and report them
}
\examples{
data(parents_geno)
data(snp_geno_gr)
corrected_geno <- correctGT(gt_matrix = GenomicRanges::mcols(snp_geno_gr),
ref = parents_geno$ref,alt = parents_geno$alt,fail = "Fail",
wrong_label = "Homo_ref")
GenomicRanges::mcols(snp_geno_gr) <- corrected_geno
corrected_geno <- filterGT(snp_geno_gr, min_markers = 30,min_samples = 2)
pvalues <- getDistortedMarkers(GenomicRanges::mcols(corrected_geno))
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diagnostic-qc-checks.R
\name{countBinState}
\alias{countBinState}
\title{countBinState}
\usage{
countBinState(chr, snpAnno, viState, genomeRange, ntile = 5)
}
\arguments{
\item{chr, }{character, the chromosome to check}

\item{snpAnno, }{data.frame, the SNP annotation for the supplied chromosome}

\item{viState, }{dgTMatrix/Matrix, the viterbi state matrix, output from
`sgcocaller`}

\item{genomeRange, }{GRanges object with seqlengths information for the genome}

\item{ntile, }{integer, how many tiles the chromosome is binned into}
}
\value{
a data.frame that contains chromosome bin segregation ratio
}
\description{
Bins the chromosome into supplied number of bins and find the state of
the chromosome bins across all gamete cells
}
\details{
This function is used for checking whether chromosome segregation pattern
obeys the expected ratio.
}
\examples{
 
library(IRanges)
library(S4Vectors)

chrom_info <- GenomeInfoDb::getChromInfoFromUCSC("mm10")
seq_length <- chrom_info$size
names(seq_length) <- chrom_info$chrom

dna_mm10_gr <- GenomicRanges::GRanges(
  seqnames = Rle(names(seq_length)),
  ranges = IRanges(1, end = seq_length, names = names(seq_length)),
  seqlengths = seq_length)

GenomeInfoDb::genome(dna_mm10_gr) <- "mm10"
demo_path <- system.file("extdata",package = "comapr")
sampleName <- "s1"
chr <- "chr1"
vi_mtx <- Matrix::readMM(file = paste0(demo_path,"/", sampleName, "_",
                                       chr, "_vi.mtx"))

snpAnno <- read.table(file = paste0(demo_path,"/", sampleName,
                                    "_", chr, "_snpAnnot.txt"),
                                    stringsAsFactors = FALSE,
                      header = TRUE)

countBinState(chr = "chr1",snpAnno = snpAnno,
viState = vi_mtx,genomeRange = dna_mm10_gr, ntile = 1)

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getCellCORange.R
\name{getCellCORange}
\alias{getCellCORange}
\title{getCellCORange}
\usage{
getCellCORange(co_count, cellBarcode)
}
\arguments{
\item{co_count, }{`GRanges` or `RangedSummarizedExperiment` object,}

\item{cellBarcode, }{the selected cell's barcode}
}
\value{
GRange object containing the crossover intervals for the selected
cell
}
\description{
It finds the crossover intervals for a selected cell
}
\examples{
  demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_counts <- countCOs(s1_rse_state)

co_ranges <- getCellCORange(cellBarcode = "BC1",
                            co_count = s1_counts)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-genetic-dist.R
\name{plotWholeGenome}
\alias{plotWholeGenome}
\title{Plot cumulative genetic distances across the genome}
\usage{
plotWholeGenome(gr)
}
\arguments{
\item{gr, }{GRanges object with genetic distances calculated for marker
intervals}
}
\value{
A ggplot object
}
\description{
This function takes the calculated genetic distances for all
marker intervals across all chromosomes provided and plot the
cumulative genetic distances
}
\examples{
data(coCount)
dist_se <- calGeneticDist(coCount)
plotWholeGenome(SummarizedExperiment::rowRanges(dist_se))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getCellAFTrack.R, R/getCellCORange.R
\name{getCellAFTrack}
\alias{getCellAFTrack}
\title{getCellAFTrack
Generates the DataTracks for plotting AF and crossover regions}
\usage{
getCellAFTrack(
  chrom = "chr1",
  path_loc = "./output/firstBatch/WC_522/",
  sampleName = "WC_522",
  nwindow = 80,
  barcodeFile,
  cellBarcode,
  co_count,
  snp_track = NULL,
  chunk = 1000L
)

getCellAFTrack(
  chrom = "chr1",
  path_loc = "./output/firstBatch/WC_522/",
  sampleName = "WC_522",
  nwindow = 80,
  barcodeFile,
  cellBarcode,
  co_count,
  snp_track = NULL,
  chunk = 1000L
)
}
\arguments{
\item{chrom, }{the chromosome}

\item{path_loc, }{the path prefix to the output files from sscocaller including
"*_totalCount.mtx" and "_altCount.mtx"}

\item{sampleName, }{the sample name, which is the prefix of sscocaller's output
files}

\item{nwindow, }{the number of windows for binning the chromosome}

\item{barcodeFile, }{the barcode file containing the list of cell barcodes used
as the input file for sscocaller}

\item{cellBarcode, }{the selected cell barcode}

\item{co_count, }{`GRange` or `RangedSummarizedExperiment` object,
returned by \code{countCO} that contains the crossover intervals and the number
of crossovers in each cell.}

\item{snp_track, }{the SNP position track which is used for obtaining the SNP
chromosome locations. It could be omitted and the SNP positions will be acquired
from the "*_snpAnnot.txt" file.}

\item{chunk, }{An integer scalar indicating the chunk size to use,
i.e., number of rows to read at any one time.}
}
\value{
The DataTrack object defined in \code{\link[Gviz]{DataTrack}}

The DataTrack object defined in \code{\link[Gviz]{DataTrack}}
}
\description{
It plots the raw alternative allele frequencies and highlight the crossover
regions for the selected cell.

It plots the raw alternative allele frequencies and highlight the crossover
regions for the selected cell.
}
\examples{
demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_counts <- countCOs(s1_rse_state)
af_co_tracks <- getCellAFTrack(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1",
                               barcodeFile = paste0(demo_path,
                                                    "s1_barcodes.txt"),
                               cellBarcode = "BC1",
                               co_count = s1_counts)

demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_counts <- countCOs(s1_rse_state)
af_co_tracks <- getCellAFTrack(chrom ="chr1",
                               path_loc = demo_path,
                               sampleName = "s1",
                               barcodeFile = paste0(demo_path,
                                                    "s1_barcodes.txt"),
                               cellBarcode = "BC1",
                               co_count = s1_counts)

}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{coCount}
\alias{coCount}
\title{RangedSummarizedExperiment object containing the crossover counts across
samples for the list of SNP marker intervals}
\format{
An object of class \code{RangedSummarizedExperiment} with 3 rows and 10 columns.
}
\usage{
data(coCount)
}
\description{
RangedSummarizedExperiment object containing the crossover counts across
samples for the list of SNP marker intervals
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-count.R
\name{plotCount}
\alias{plotCount}
\alias{plotCount,RangedSummarizedExperiment,missing,missing-method}
\alias{plotCount,RangedSummarizedExperiment,missing,character-method}
\alias{plotCount,RangedSummarizedExperiment,logical,character-method}
\alias{plotCount,RangedSummarizedExperiment,logical,missing-method}
\alias{plotCount,GRanges,logical,missing-method}
\alias{plotCount,GRanges,missing,missing-method}
\alias{plotCount,GRanges,missing,character-method}
\alias{plotCount,GRanges,logical,character-method}
\title{plotCount}
\usage{
plotCount(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{RangedSummarizedExperiment,missing,missing}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{RangedSummarizedExperiment,missing,character}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{RangedSummarizedExperiment,logical,character}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{RangedSummarizedExperiment,logical,missing}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{GRanges,logical,missing}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{GRanges,missing,missing}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{GRanges,missing,character}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)

\S4method{plotCount}{GRanges,logical,character}(
  co_count,
  by_chr = FALSE,
  group_by = "sampleGroup",
  plot_type = "error_bar"
)
}
\arguments{
\item{co_count}{GRange or RangedSummarizedExperiment object, returned by \code{countCO}}

\item{by_chr, }{whether it should plot each chromosome separately}

\item{group_by, }{the column name in `colData(co_count)` that specify the
grouping factor. Or the character vector contains the unique prefix of
sample names that are used for defining different sample groups. If missing
all samples are assumed to be from one group}

\item{plot_type, }{determins what type the plot will be, choose from "error_bar"
or "hist". Only relevant when by_chr=TRUE}
}
\value{
ggplot object
}
\description{
Plot the number of COs per sample group or per chromosome
}
\examples{
demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 0)
s1_count <- countCOs(s1_rse_state)
plotCount(s1_count)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{parents_geno}
\alias{parents_geno}
\title{Parents' genotype for F1 samples in `snp_geno`}
\format{
A data.frame:
\describe{
 \item{C57BL.6J}{genotype of reference mouse train across markers}
 \item{FVB.NJ..i.}{genotype of alternative mouse train across markers}
}
}
\usage{
data(parents_geno)
}
\description{
Parents' genotype for F1 samples in `snp_geno`
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-genetic-dist.R
\name{plotGeneticDist}
\alias{plotGeneticDist}
\title{plotGeneticDist}
\usage{
plotGeneticDist(gr, bin = TRUE, chr = NULL, cumulative = FALSE)
}
\arguments{
\item{gr}{GRanges object with genetic distances calculated for marker
intervals}

\item{bin}{TRUE or FALSE, indicating whether the supplied GRange objecct
is for binned interval}

\item{chr}{the specific chrs selected to plot}

\item{cumulative}{TRUE or FALSE, indicating whether it plots the bin-wise
genetic distances or the cumulative distances}
}
\value{
ggplot2 plot
}
\description{
Plotting the calculated genetic distanced for each bin or marker interval
supplied by the GRanges object
}
\examples{
data(coCount)
dist_se <- calGeneticDist(coCount)
plotGeneticDist(SummarizedExperiment::rowRanges(dist_se))
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read-hap-state.R
\name{readHapState}
\alias{readHapState}
\title{readHapState}
\usage{
readHapState(
  sampleName,
  chroms = c("chr1"),
  path,
  barcodeFile = NULL,
  minSNP = 30,
  minlogllRatio = 200,
  bpDist = 100,
  maxRawCO = 10,
  nmad = 1.5,
  minCellSNP = 200,
  biasTol = 0.45
)
}
\arguments{
\item{sampleName, }{the name of the sample to parse which is used as prefix for
finding relevant files for the underlying sample}

\item{chroms, }{the character vectors of chromosomes to parse. Multiple chromosomes'
results will be concated together.}

\item{path, }{the path to the files, with name patterns *{chrom}_vi.mtx,
*{chrom}_viSegInfo.txt, end with slash}

\item{barcodeFile, }{if NULL, it is assumed to be in the same directory as the
other files and with name sampleName_barcodes.txt}

\item{minSNP}{the crossover(s) will be filtered out if introduced by a segment
that has fewer than `minSNP` SNPs to support.}

\item{minlogllRatio}{the crossover(s) will be filtered out if introduced by a
segment that has lower than `minlogllRatio` to its reversed state.}

\item{bpDist, }{the crossover(s) will be filtered out if introduced by a segment
that is shorter than `bpDist` basepairs. It can be a single value or a vector
that is the same length and order with `chroms`.}

\item{maxRawCO}{if a cell has more than `maxRawCO` number of raw crossovers
called across a chromosome, the cell is filtered out}

\item{nmad}{how many mean absolute deviations lower than the median number
of SNPs per cellfor a cell to be considered as low coverage cell and filtered
Only effective when number of cells are larger than 10. When effective, this or
`minCellSNP`, whichever is larger, is applied}

\item{minCellSNP}{the minimum number of SNPs detected for a cell to be kept,
used with `nmads`}

\item{biasTol}{the SNP's haplotype ratio across all cells is assumed
to be 1:1. This argument can be used for removing SNPs that have a biased
haplotype. i.e. almost always inferred to be haplotype state 1. It specifies
a bias tolerance value, SNPs with haplotype ratios deviating from 0.5 smaller
than this value are kept. Only effective when number of cells are larger than
10}
}
\value{
a RangedSummarizedExperiment with rowRanges as SNP positions that
contribute to crossovers in any cells. colData contains cells annotation
including barcodes and sampleName.
}
\description{
A function that parses the viterbi state matrix (in .mtx format),
barcode.txt and snpAnno.txt files for each individual.
}
\examples{
demo_path <- system.file("extdata",package = "comapr")
s1_rse_state <- readHapState(sampleName="s1",chroms=c("chr1"),
path=paste0(demo_path,"/"),
barcodeFile=NULL,minSNP = 0, minlogllRatio = 50,
bpDist = 100,maxRawCO=10,minCellSNP=3)
s1_rse_state
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diagnostic-qc-checks.R
\name{perCellChrQC}
\alias{perCellChrQC}
\title{perCellChrQC}
\usage{
perCellChrQC(
  sampleName,
  chroms = c("chr1", "chr7", "chr15"),
  path,
  barcodeFile = NULL,
  doPlot = TRUE
)
}
\arguments{
\item{sampleName, }{the name of the sample to parse which is used as prefix
for finding relevant files for the underlying sample}

\item{chroms, }{the character vectors of chromosomes to parse. Multiple
chromosomes' results will be concated together.}

\item{path, }{the path to the files, with name patterns *{chrom}_vi.mtx,
*{chrom}_viSegInfo.txt, end with slash}

\item{barcodeFile, }{defaults to NULL, it is assumed to be in the same d
irectory as the other files and with name sampleName_barcodes.txt}

\item{doPlot, }{whether a plot should returned, default to TRUE}
}
\value{
a list object that contains the data.frame with summarised statistics
per chr per cell and a plot (if doPlot)
}
\description{
A function that parses output ('_viSegInfo.txt' )from `sgcocaller`
\url{https://gitlab.svi.edu.au/biocellgen-public/sgcocaller} and
generate cell cell (per chr) summary statistics
}
\examples{
demo_path <-system.file("extdata",package = "comapr")
pcQC <- perCellChrQC(sampleName="s1",chroms=c("chr1"),
path=demo_path,
barcodeFile=NULL)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read-col-mm.R
\name{readColMM}
\alias{readColMM}
\title{readColMM}
\usage{
readColMM(file, which.col, chunk = 1000L)
}
\arguments{
\item{file}{the name of the file to be read from as a character scalar. Those
storing matrices in the MatrixMarket format usually end in ".mtx".}

\item{which.col}{An integer scalar, the column index}

\item{chunk, }{An integer scalar indicating the chunk size to use,
i.e., number of rows to read at any one time.}
}
\value{
A sparse matrix object that inherits from the "Matrix" class which the original
dimensions.To get the vector of the specified column, one need to subset
the matrix to select the column with the same index.
}
\description{
Modified the `Matrix::readMM` function for reading matrices stored in the
Harwell-Boeing or MatrixMarket formats but only reads selected column.
}
\details{
See \code{\link[Matrix]{readMM}}
}
\examples{
demo_path <-paste0(system.file("extdata",package = "comapr"),"/")
readColMM(file = paste0(demo_path,"s1_chr1_vi.mtx"), which.col=2,chunk=2)
}
\author{
Ruqian Lyu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/comapr.R
\docType{package}
\name{comapr}
\alias{comapr}
\title{\code{comapr} package}
\description{
crossover inference package
}
\details{
See the README on
 \href{https://gitlab.svi.edu.au/biocellgen-private/comapr}{GitLab}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reformat-geno-mt.R
\name{.label_gt}
\alias{.label_gt}
\title{`label_gt` for changing genotypes in alleles format to labels}
\usage{
.label_gt(s_gt, ref, alt, failed = "Fail")
}
\arguments{
\item{s_gt}{s_gt, a vector of genotypes for one sample across markers}

\item{ref}{ref, a vector of genotypes for reference strain across markers}

\item{alt}{alt, a vector of genotypes for alternative strain across markers}

\item{failed}{what was used for encoding failed genotype calling such as "Fail" in example}
}
\value{
a vector of labels \code{Homo_ref, Homo_alt, Het} indicating the progeny's
genotypes across markers
}
\description{
It turns a vector of Genotypes to a vector of Labels consist of
`Homo_ref`, `Homo_alt`, and `Het` given the known genotypes for reference
and alternative strains.
}
\details{
This function takes the a sample's genotype across each SNP marker in alleles
and compare with genotypes of in-bred reference and alternative strains to.
If the sample's genotype for a particular SNP marker is the same with the
reference strain, it is labelled as Homo_ref \code{homogeneous reference} for
a particular SNP marker; if the sample's genotype is the same with the
alternative strain it is labelled as Homo_alt \code{homogeneous alternative}
for a particular SNP marker; if the sample's genotype is heterozygous then it
is labeled as Het \code{heterozygous} for this particular genotypes. If it
does not fall in any of the three cases, it is labelled as the string
specified by the argument `missing`.

Note that the wrong/failed genotype is labelled as the string in `missing`
after this function.
If there is a different label for failed genotype, provide the label using
the `missing` argument.
}
\author{
Ruqian Lyu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineHapState.R
\name{combineHapState}
\alias{combineHapState}
\title{combineHapState}
\usage{
combineHapState(rse1, rse2, groupName = c("Sample1", "Sample2"))
}
\arguments{
\item{rse1, }{the first `RangedSummarizedExperiment`}

\item{rse2, }{the second `RangedSummarizedExperiment`}

\item{groupName, }{a character vector of length 2 that contains the first and
the second group's names}
}
\value{
A `RangedSummarizedExperiment` that contains the cells and SNPs in
both `rse`
}
\description{
combine two `RangedSummarizedExperiment` objects, each contains the haplotype
state for a list of SNPs across a set of cells. The combined result will have
cells from two individuals and merged list of SNPs from the two.
}
\examples{
BiocParallel::register(BiocParallel::SnowParam(workers = 1))
demo_path <- paste0(system.file("extdata",package = "comapr"),"/")
s1_rse_state <- readHapState("s1",chroms=c("chr1"),
                             path=demo_path,barcodeFile=NULL,minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 1)

s2_rse_state <- readHapState("s2",chroms=c("chr1"),
                             path=demo_path,
                             barcodeFile=paste0(demo_path,"s2_barcodes.txt"),
                             minSNP = 0,
                             minlogllRatio = 50,
                             bpDist = 100,maxRawCO=10,
                             minCellSNP = 1)
sb <- combineHapState(s1_rse_state,s2_rse_state)

}
\author{
Ruqian Lyu
}
